/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package learning.benchmarks;

import learning.SuccessBasedLearner;

import java.util.List;
import solution.Solution;
import learning.parameters.Bin;
import learning.parameters.Parameter;
import utility.CommonFunctions;


public class ExtremeCreditAssignment extends SuccessBasedLearner{
	
	/**
	 * Populate New parameters for Executor Instances.
	 * Use Previously calculated Success rates and select the bin from a discrete distribution
	 * weighted from the success rates.
	 * @param mapExInstance
	 * @param iCompletedIteration LastCompletedIteration
	 */
	@Override
	public void prepareInstancesForNextIteration(List<Solution> population,int iCompletedIteration){

            int window = 5;
            for(Solution sol: population){
                for( Parameter param : sol.getParameterMap().values()){
                    List<Bin> lstBins = param.getListBins();
                    int inBins = lstBins.size();
                    double[] adProbValues = new double[inBins];
                    String sRul = "";
                    for( int i=0; i<inBins; i++){
                        adProbValues[i] = (lstBins.get(i)).getBinPerformance().getExtremeSuccessInWindow(window);
                        sRul += adProbValues[i] + ",";
                    }
                    int iBinIndex = CommonFunctions.doRoulette(adProbValues);
                    lstBins.get(iBinIndex).setCurrentValueRandomly();
                    param.setCurrentBin(lstBins.get(iBinIndex));

                }
            }
	}
}
