/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package learning.forecast;

import utility.forecasting.EWMA;


import java.util.List;
import java.util.Map;
import learning.parameters.Bin;
import learning.parameters.Parameter;

public class EWMAForecast extends ForecastBasedLearner{
    private double d_Lambda = 0.3; /** Degree of Weighting Decrease **/

    @Override
    public void forecast(int iCompletedIteration){
        for(Map.Entry paramEntry : lstParametersToControl.entrySet()){
            Parameter param = (Parameter) paramEntry.getValue();
            Parameter newParameter = param.clone();
            List<Bin> lstBins = param.getListBins();
            int inBins = lstBins.size();
            for( int i=0; i<inBins; i++){
                List<Double> adHistory = lstBins.get(i).getBinPerformance().getSuccessRateHistory();             
                EWMA ewmaModel = new EWMA(adHistory, d_Lambda);
                double predictedPerformance = ewmaModel.getNextPrediction();
                (lstBins.get(i)).getBinPerformance().setPredictedSuccessRateHistory(iCompletedIteration,predictedPerformance);

            }

        }
    }
    
}
