/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package learning.forecast;
import java.util.List;
import jsc.datastructures.PairedData;
import jsc.regression.PearsonCorrelation;
import learning.parameters.Bin;
import learning.parameters.Parameter;
import utility.CommonFunctions;

public class PearsonForecast extends ForecastBasedLearner{


    @Override
    public void forecast(int iCompletedIteration){
        for( Parameter param : lstParametersToControl.values()){
            List<Bin> lstBins = param.getListBins();

            for( int i=0; i<lstBins.size(); i++){
                List<Double> adHist = lstBins.get(i).getBinPerformance().getSuccessRateHistory();
                double[] adHistory = new double[adHist.size()];
                for(int j=0; j<adHist.size();j++)
                    adHistory[j]= adHist.get(j);
                double[] adIndexSet = CommonFunctions.getIndexSet(adHistory);
                PairedData o_PairedData = new PairedData(adIndexSet, adHistory);
                PearsonCorrelation o_PearsonCorrelation = null;
                try {
                        o_PearsonCorrelation = new PearsonCorrelation(o_PairedData);
                } catch (Exception ex) {
                        System.out.println(ex.toString());
                        return;
                }

                double A = o_PearsonCorrelation.getA();
                double B = o_PearsonCorrelation.getB();
                double r = o_PearsonCorrelation.getR();

                double next = A + B * (iCompletedIteration+1);

                double predictedPerformance=next;
                (lstBins.get(i)).getBinPerformance().setPredictedSuccessRateHistory(iCompletedIteration, predictedPerformance);

            }
          
              
            
        }
    }

}
