package learning.forecast;

import java.util.List;
import java.util.Map;
import learning.parameters.Bin;
import learning.parameters.Parameter;
import utility.forecasting.SMA;

/**
 *
 * @author Alda
 */
public class SMAForecast extends ForecastBasedLearner{
    private int window =3;

    @Override
    public void forecast(int iCompletedIteration){
        for(Map.Entry paramEntry : lstParametersToControl.entrySet()){
            Parameter param = (Parameter) paramEntry.getValue();
            List<Bin> lstBins = param.getListBins();
            int inBins = lstBins.size();
            double[] adProbValues = new double[inBins];
            for( int i=0; i<inBins; i++){
                List<Double> adHistory =  lstBins.get(i).getBinPerformance().getSuccessRateHistory();
                SMA smaModel = new SMA(adHistory, window);
                adProbValues[i]= smaModel.getNextPrediction();
                (lstBins.get(i)).getBinPerformance().setPredictedSuccessRateHistory(iCompletedIteration,adProbValues[i]);

            }
        }
    }
}
