package learning.parameters;

import java.util.LinkedList;
import java.util.List;
import java.util.Random;
import utility.Utils;

/**
 *
 * @author Alda
 */
public class Parameter {
    protected Object name;
    protected List<Bin> listBins;
    protected Bin currentBin;
    protected double[] cutPoints;

    public Parameter(Object sName){
        name = sName;
        listBins = new LinkedList<Bin>();
    }

    private Parameter() {}

    public double[] getCutPoints(){
        return cutPoints;
    }
    
    public void setCutPoints(double... cPoints){
        cutPoints = new double[cPoints.length];
        System.arraycopy(cPoints, 0, cutPoints, 0, cPoints.length);
    }

    public Bin getBin(int index){
        return listBins.get(index);
    }

    public void setName(Object newName){
        name=newName;
    }
    public void setListBins(List<Bin> newLstBins){
        listBins = new LinkedList<Bin>();
        for(Bin bin:newLstBins){
            listBins.add(bin);
        }
    }
    @Override
    public Parameter clone(){
        Parameter newParameter = new Parameter();
        newParameter.setName(name);
        newParameter.setCurrentBin(currentBin);    
        newParameter.setListBins(listBins);
        return newParameter;
    }
    public Object getName(){ return name;  }

    public void setCurrentBin(Bin newBin){
	currentBin = newBin.clone();
    }
    public void setCurrentBin(int binIndex){
        currentBin = listBins.get(binIndex);
    }
    public Bin getCurrentBin(){ return currentBin;}
    public int getLevels(){return 1;}

    public void initialiseBins(){
          listBins = new LinkedList<Bin>();
    }
    public List<Bin> getListBins(){
        return listBins;
    }
    public void initialiseRandomly(){
       Random random = Utils.random;
       int index = random.nextInt(listBins.size());
       currentBin = listBins.get(index).clone();
       currentBin.setCurrentValueRandomly();
    }

    public String toString(String pMetric, int nIterations){
        String st ="Parameter,"+name.toString()+",List of Bins";
        for(Bin bin: listBins){
            if(this instanceof ValueParameter){
                st+=","+((ValueBin)bin).getMin()+","+((ValueBin)bin).getMax()+",Performance,"+((ValueBin)bin).getBinPerformance().getAveragePerformanceHistory(pMetric, nIterations);
            }
            else{
                st+=","+((ObjectBin)bin).getAlias()+",";
            }
        }
        
        return st;
    }
}
