package learning.parameters;

import java.io.Serializable;
import utility.Utils;


public class ValueBin extends Bin implements Serializable{
    private double maxValue;
    private double minValue;

    @Override
    public Object getAlias(){
        return "Max,"+maxValue+",Min,"+minValue;
    }
    public ValueBin ( double dMin, double dMax, int ind){
        super(ind);
        maxValue = dMax;
        minValue = dMin;
    }

    @Override
    public Bin clone(){
        Bin newBin = new ValueBin(minValue, maxValue, index);
        newBin.setCurrentValue(currentValue);
        newBin.setBinPerformance(getBinPerformance().clone());
        return newBin;
    }
    public double getMin(){ 
        return minValue;
    }
    public double getMax(){ 
        return maxValue;
    }

    public void setMin(double min){
        minValue=min;
    }
    public void setMax(double max){
        maxValue=max;
    }
    @Override
    public void setCurrentValueRandomly(){
        currentValue = (Double) minValue + Utils.random.nextDouble() * ((Double)maxValue -(Double)minValue);
    }

}
