package learning.parameters;

import java.io.Serializable;
/*
 * @author aaleti
 */
public class ValueParameter extends Parameter implements Serializable {
    private double maxValue;
    private double minValue;
    private int nBins;

    public ValueParameter(Object sName, int numberBins, double dMin, double dMax){
        super(sName);
        nBins =numberBins;
        minValue = dMin;
        maxValue = dMax;
    }
    
    @Override
    public Parameter clone(){
        Parameter newParameter = new ValueParameter(name, nBins, minValue, maxValue);
        if(currentBin!=null)
            newParameter.setCurrentBin(currentBin);
        if(listBins!=null)
            newParameter.setListBins(listBins);
        return newParameter;
    }  

    public double getMinValue(){
        return minValue;
    }

    public double getMaxValue(){
        return maxValue;
    }

    @Override
    public int getLevels(){return nBins;}

    @Override
    public void initialiseBins(){
        super.initialiseBins();
        double intervalLength = ((Double)maxValue - (Double)minValue) / nBins;
        for (int iLvl = 0; iLvl < nBins; iLvl++) {
            double mn = (double) minValue + iLvl * intervalLength;
            double mx = (double) minValue + (iLvl + 1) * intervalLength - intervalLength / 100000;
            Bin b = new ValueBin(mn, mx, iLvl);
            listBins.add(b);
        }
    }    
}
