package problem.QAP;

import java.util.Properties;
import java.util.Scanner;
import problem.Problem;

public class MOQAPProblem extends Problem
{
    private int objectives;
    private int[][] distanceMatrix;
    private int[][][] flowMatrices;
    private double[] maxObjectiveValues;
    private int options;

    public MOQAPProblem(){

    }
    public MOQAPProblem(int card, int dims){
	objectives= dims;
	cardinality = card;
	distanceMatrix = new int[card][card];
	flowMatrices = new int[dims][card][card];	
    }
    
    public int[][]  getDistanceMatrix(){
        return distanceMatrix;
    }

    public int[][][] getFlowMatrix(){
        return flowMatrices;
    }
    public void fillMatrices(Scanner sc)
    {
	fillMatrix(sc, -1);
	for (int i = 0; i < objectives; i++)
	{
	    sc.nextLine();
	    fillMatrix(sc, i);
	}
    }

    private void fillMatrix(Scanner sc, int matrix)
    {
	int[][] tempMatrix;
	if (matrix == -1)
	    tempMatrix = distanceMatrix;
	else
	    tempMatrix = flowMatrices[matrix];

	for (int i = 0; i< tempMatrix.length; i++)
	    for(int j = 0; j < tempMatrix[i].length; j++)
	    { 
		tempMatrix[i][j] = sc.nextInt();
	    }
    }
    
   

    @Override
    public void initialise(Properties props)
    {
        super.initialise(props);
        maxObjectiveValues = new double[objectives];
    }
 public double getMaxValueForObjective(int obj)
    {
	return maxObjectiveValues[obj];
    }
    public void setMaxObjectiveValues(String [] maxHVs)
    {
	for (int i = 0; i < maxHVs.length; i++)
	{
	    maxObjectiveValues[i] = Double.parseDouble(maxHVs[i]);
	}
    }
    
    @Override
    public int getOptions()
    {
	return options;
    }
    
    
    @Override
    public int getCardinality()
    {
	return cardinality;
    }


    @Override
    public int getObjectives()
    {
	return objectives;
    }
    
}
