
package problem.RoyalRoad;

import java.util.Properties;
import problem.Problem;


/**
 *
 * @author Alda
 */
public class RoyalRoadProblem extends Problem{

    private int blockSize;
    private int gapSize;
    private int regionSize;
    private int blockCount;
    private int levels;
    private int stringSize;
    private int partFitness;
    private double partValue;
    private double bonusStartValue;
    private double bonusValue;

    private int options;

    public int getBlockCount(){
        return blockCount;
    }
    public int getBlockSize(){
        return blockSize;
    }

    public double getPartValue(){
        return partValue;
    }
    public double getPartFitness(){
        return partFitness;
    }

    public int getLevels(){
        return levels;
    }
    public int getRegionSize(){
        return regionSize;
    }
    public double getBonusStartValue(){
        return bonusStartValue;
    }
    public double getBonusValue(){
        return bonusValue;
    }
    
    @Override
    public void initialise(Properties props){
        super.initialise(props);
        blockSize = 4;
        gapSize = 3;
        regionSize = blockSize + gapSize;
        levels = 2;
        blockCount = (int) Math.pow(2, levels);
        stringSize = (blockSize+gapSize)* blockCount;
        cardinality = stringSize;
        partFitness = 4;
        partValue = 0.02;
        bonusStartValue =1.0;
        bonusValue = 0.3;
        options=3;

    }
    @Override
    public int getOptions(){
        return options;
    }

}
