package solution.QAP;

import problem.Problem;
import problem.QAP.MOQAPProblem;
import solution.MOSolution;
import utility.OutOfFunctionEvaluationsException;

public class MOQAPSolution extends MOSolution
{

    @Override
    public void evaluateSolution(Problem p) throws OutOfFunctionEvaluationsException{

	for (int i = 0; i < p.getObjectives(); i++){
            p.incrementFE();
	    evaluateObjective(p,i);
            if(!p.availableFunctionEvaluations()){
                throw new OutOfFunctionEvaluationsException();
            }
	}
    }
    private void evaluateObjective(Problem p, int obj){
	int result = 0;
	for (int i = 0; i < p.getCardinality(); i++)
	{
	    for (int j = 0; j < p.getCardinality(); j++)
		result += ((MOQAPProblem)p).getDistanceMatrix()[i][j] * ((MOQAPProblem)p).getFlowMatrix()[obj][(Integer)getAssignmentForPosition(i)][(Integer)getAssignmentForPosition(j)];
	}
	setFitnessForObjective(result, obj);
    }

    @Override
    public MOSolution clone(){
	MOSolution solution = new MOQAPSolution();
        solution.structure = new Object[structure.length];
        System.arraycopy(this.structure, 0, solution.structure, 0, structure.length);
        solution.setParameterMap(getParameterMap());
	return solution;
    }
}
