package solution;

import java.util.HashMap;
import java.util.Map.Entry;
import problem.Problem;
import learning.parameters.Parameter;
import utility.OutOfFunctionEvaluationsException;

import utility.Utils;

public class Solution {
    
    public Object [] structure;
    protected boolean valid;
    protected double currentFitness = 0;
    protected double fitnessChange= 0;
    protected double penaltyFitness;
    private HashMap<Object, Parameter> parameterMap;

    @Override
    public Solution clone(){
        Solution newSolution = new Solution();
        newSolution.fitnessChange = fitnessChange;
        newSolution.currentFitness = currentFitness;
        newSolution.setParameterMap(parameterMap);
        newSolution.setValid(valid);
        newSolution.structure = new Object[structure.length];
        System.arraycopy(structure, 0, newSolution.structure, 0, structure.length);
        return newSolution;
    }

    public double getFitnessChange(){return fitnessChange;}
    public void setFitnessChange(double fitness){fitnessChange = fitness;}

    public HashMap<Object, Parameter> getParameterMap(){return parameterMap;}
    public void setParameterMap(HashMap<Object, Parameter> params){
        if(params!=null){
            parameterMap = new HashMap<Object, Parameter>();
            for(Entry pEntry : params.entrySet()){
                Parameter newParam = ((Parameter)pEntry.getValue()).clone();
                parameterMap.put(pEntry.getKey(), newParam);
            }
        }
    }

    public double getPenaltyFitness(){ return penaltyFitness;}
    public void setPenaltyFitness(double penaltyF){penaltyFitness = penaltyF;}

    public double getCurrentFitness(){ return currentFitness;}
    public void setCurrentFitness(double fitness){      
        double fChange = fitness-currentFitness;
        if(fChange > 0) fitnessChange = fChange;
        else fitnessChange = 0;
        currentFitness = fitness;
    }
    public void initialise(int n){structure = new Object[n];}
    public void initialiseRandomly(Problem p){}

    public Object getAssignmentForPosition(int position){return structure[position];}
    public void setAssignmentForPosition(int position, Object value){structure[position] = value;}
    public Object[] getStructure(){return structure;}

    public void setValid(boolean vld){valid = vld;}
    public boolean isValid(){return valid;}
    @Override
    public String toString(){
        String s = "";
        for (int i = 0; i < structure.length; i++)
            s+= structure[i]+" ";
        
        return s;
    }
    public Solution uniformSwapMutatation(double mutationRate) {
        Solution sol = clone();
        if(parameterMap != null){
            mutationRate = (Double)parameterMap.get("mutationRate").getCurrentBin().getCurrentValue();
        }
        for(int i= 0 ; i< structure.length; i++){
            if(Utils.random.nextDouble()< mutationRate){
                Object obj1 = sol.structure[i];
                int temp2 = Utils.random.nextInt(structure.length);
                Object obj2 = sol.structure[temp2];
                sol.structure[i]= obj2;
                sol.structure[temp2] = obj1;
            }
        }
        return sol;
    }

    public Solution[] crossover(Solution sol2){
        return uniformCrossover(sol2);
    }

    public Solution mutation(double rate){
        return uniformSwapMutatation(rate);
    }
    
    public Solution[] uniformCrossover(Solution sol2){
        Solution [] children = new Solution[2];
        children [0] = this.clone();
        children [1] = sol2.clone();
        double crossoverRate = (Double)this.getParameterMap().get("crossoverRate").getCurrentBin().getCurrentValue();
        double temp = (Double)sol2.getParameterMap().get("crossoverRate").getCurrentBin().getCurrentValue();
        if(temp > crossoverRate)
            crossoverRate = temp;
        for (int i = 0; i < structure.length; i++){
            if (Utils.random.nextDouble() <= crossoverRate){
                children[0].setAssignmentForPosition(i, sol2.structure[i]);
                children[1].setAssignmentForPosition(i, structure[i]);
            } else{
                children[0].setAssignmentForPosition(i, structure[i]);
                children[1].setAssignmentForPosition(i, sol2.structure[i]);
            }
        }
        return children;
    }
    public Solution[] corssover(Solution parentSolution, double cRate){return null;};
    public Solution[] singlePointCrossover(Solution parentSolution){return null;};
    public Solution singlepointMutation(){return this;}
    public String getSolutionInSequence(){return null;}
    public void evaluateSolution(Problem p)throws OutOfFunctionEvaluationsException{}
  
}
