package solver.multiobjective;

import java.util.Collections;
import java.util.LinkedList;
import java.util.List;
import solution.MOSolution;
import solution.Solution;
import utility.reporting.Reporting;


public class ARMOAlgorithm extends MOGA{ 

    @Override
    protected void createMatingPool(){
        List<Solution> pointerPopulation =new LinkedList<Solution>();
        for(MOSolution sol: MOPopulation){
            pointerPopulation.add(sol);
        }
	currentMOComparator.prepare(pointerPopulation);
	while(matingPool.size() < matingPoolSize)
	{
	    matingPool.add(doTournamentSelection());
	}
	currentMOComparator.unprepare();
    }
    
    @Override
    protected void doSelection()
    {
        List<Solution> pointerPopulation = new LinkedList<Solution>();
        for(MOSolution sol: MOPopulation){
            pointerPopulation.add(sol);
        }
	currentMOComparator.prepare(pointerPopulation);
	Collections.sort(MOPopulation, currentMOComparator);
	currentMOComparator.unprepare();
	/*    System.out.println("Next pop");
	    for (int j = 0; j < population.size(); j++)
	    {
		System.out.println("Rank "+population.get(j).getRanking().getAverageRanking());

	    }*/
	int i = MOPopulation.size()-1;
	double currentRank = MOPopulation.get(i--).getRanking().getAverageRanking();
	while (i >= 0)
	{
	    if (MOPopulation.get(i).getRanking().getAverageRanking() == currentRank)
	    {
		if(MOPopulation.get(i).isDuplicate(MOPopulation.get(i+1)))
		    MOPopulation.remove(i) ;
	    }
	    
	    i--;
	}
	i = MOPopulation.size()-1;
	while(MOPopulation.size() > populationSize)
	    MOPopulation.remove(i--);
    }

    @Override
    public void oneIteration(Reporting reporting) {
        throw new UnsupportedOperationException("Not supported yet.");
    }
}
