package solver.multiobjective;

import java.util.Collections;
import java.util.LinkedList;
import java.util.List;
import solution.MOSolution;
import solution.Solution;
import utility.reporting.Reporting;



public class Hype extends MOGA
{
    
    @Override
    protected void createMatingPool()
    {
        List<Solution> pointerPopulation = new LinkedList<Solution>();
        for(MOSolution sol: MOPopulation){
            pointerPopulation.add(sol);
        }
	currentMOComparator.prepare(pointerPopulation);
	while(matingPool.size() < matingPoolSize)
	{
	    matingPool.add(doTournamentSelection());
	}
	currentMOComparator.unprepare();

    }
    
    @Override
    protected void doSelection()
    {
	fastExtractNonDomFronts();
	MOPopulation.clear();
	for (int i=0; i<nondominatedFronts.size(); i++)
	{
	    LinkedList<MOSolution> list = nondominatedFronts.get(i);
	    if (MOPopulation.size()+list.size() < populationSize)
		MOPopulation.addAll(list);
	    else if(MOPopulation.size() < populationSize)
	    {
		LinkedList<Solution> restList = new LinkedList<Solution>();
		for (int j = i; j < nondominatedFronts.size(); j++)
		{
		    restList.addAll(nondominatedFronts.get(j));
		}
		addRestBasedOnHV( restList);
	    }
	/*    System.out.println("Next front");
	    for (int j = 0; j < list.size(); j++)
	    {
		System.out.println(list.get(j));
		
	    }*/
	}
    }
    
    private void addRestBasedOnHV(List<Solution> restList)
    {
	currentMOComparator.prepare(restList);
	Collections.sort(restList, currentMOComparator);
	currentMOComparator.unprepare();
	for (int i = 0; i < populationSize - MOPopulation.size(); i++)
	{
	    MOPopulation.add((MOSolution)restList.get(i));
	}
	
/*	System.out.println("Ordered list ");
	for( int i = 0; i < restList.size(); i++ )
	{
	    System.out.println(((MOGASolution)restList.get(i)).getHypervolume()+" "+restList.get(i));
	}*/

    }

    @Override
    public void oneIteration(Reporting reporting) {
        throw new UnsupportedOperationException("Not supported yet.");
    }

}
