package utility;
import java.io.*;
import java.util.BitSet;
import java.util.Random;
import java.util.Scanner;

import problem.QAP.*;

public class FileHandler
{
    public ConstrainedQAPProblem getConstrainedProblemFromFile(String fileName)
    {
	try
	{
	    Scanner sc = new Scanner(new File(fileName));
	    int length = sc.nextInt();
	    int items = sc.nextInt();
	    ConstrainedQAPProblem problem = new ConstrainedQAPProblem(length, items);
	    problem.fillMatrix(sc);

	    return problem;
	    
	} catch (Exception e)
	{
	    System.out.print(e.toString());
	}
	return null;
    }
    public SOQAPProblem getProblemFromFile(String fileName)
    {
	try
	{
	    Scanner sc = new Scanner(new File(fileName));
	    int length = sc.nextInt();
	    SOQAPProblem problem = new SOQAPProblem(length);
	    problem.fillMatrix(sc);

	    return problem;

	} catch (Exception e)
	{
	    System.out.print(e.toString());
	}
	return null;
    }
    public MOQAPProblem getMOProblemFromFile(String fileName)
    {
	try
	{
	    MOQAPProblem newProblem = null;
	    Scanner sc = new Scanner(new File(fileName));
	    String temp = sc.nextLine();
	    String[] parameters = temp.split(" ");
	    
	    if (parameters[0].equals("facilities") && parameters[3].equals("objectives"))
		newProblem = new MOQAPProblem(Integer.parseInt(parameters[2]), Integer.parseInt(parameters[5]));
	    sc.nextLine();
	    if (sc.hasNext("HVReferencePoints"))
	    {
		temp = sc.nextLine();
		parameters = temp.split(" ");
		parameters = parameters[2].split(",");
		
		((MOQAPProblem)newProblem).setMaxObjectiveValues(parameters);
	    }
	    newProblem.fillMatrices(sc);
	    return newProblem;
	} catch (Exception e)
	{
	    System.out.print(e.toString());
	}
	return null;
    }
    
    public void writeQAPProblem(String fileName, int n)
    {
	try
	{
	    int x,y =0;
	    Random random = new Random(System.currentTimeMillis());
	    int[][] path = new int[n][n];
	    BitSet used = new BitSet(n);
	    int alku = random.nextInt(n);
	    x = alku;
	    used.set(x);
	    while (used.cardinality() < n)
	    {
		do{
		    y = random.nextInt(n);
		 
		}while (used.get(y) && used.cardinality() < n);
		used.set(y);
		path[x][y]=1;
		x = y;
	    }
	    path[y][alku] = 1;
	    PrintWriter out = new PrintWriter(new File(fileName));
	    out.println(n);
	    for (int i = 0; i< n; i++)
	    {
		out.println();
		for (int j = 0; j < n; j++)
		{	    
		    out.print(path[i][j]+"\t");
		}
		    
	    }
	    out.println();
	    out.flush();
	} catch (Exception e)
	{
	    System.out.print(e.toString());
	}
    }

 
}

