
package utility.forecasting;

import java.io.Serializable;

public class Difference
    implements Serializable, Cloneable
{

    private int nlost;
    private int nobsx;
    private int imiss;
    private int ndiff;
    private int iord[];
    private int iper[];
    private boolean user_supplied_order;

    public Difference()
    {
        user_supplied_order = false;
        nlost = 0;
        nobsx = 0;
        imiss = 0;
    }

    public void setOrders(int ai[])
    {
        iord = ai;
        for(int i = 0; i < iord.length; i++)
            if(iord[i] < 0)
            {
                Object aobj[] = {
                    new Integer(i), new Integer(iord[i])
                };
                System.out.println("Difference.OrderNeg"+aobj);
            }

        user_supplied_order = true;
    }

    public int getObservationsLost()
    {
        return nlost;
    }

    public void excludeFirst(boolean flag)
    {
        if(flag)
            imiss = 1;
        else
            imiss = 0;
    }

    public final double[] compute(double ad[], int ai[])
        throws IllegalArgumentException
    {
        ndiff = ai.length;
        iper = new int[ai.length];
        for(int i = 0; i < ai.length; i++)
            iper[i] = ai[i];

        double ad2[] = new double[ad.length];
        System.arraycopy(ad, 0, ad2, 0, ad.length);
        if(!user_supplied_order)
        {
            iord = new int[iper.length];
            for(int j = 0; j < iper.length; j++)
                iord[j] = 1;

        } else
        if(iord.length != iper.length)
        {
            Object aobj[] = {
                new Integer(iord.length), new Integer(iper.length)
            };
            System.out.println( "Difference.OrderInvalid"+ aobj);
        }
        for(int k = 1; k <= ndiff; k++)
            if(iper[k - 1] < 1)
            {
                Object aobj1[] = {
                    new Integer(k - 1), new Integer(iper[k - 1])
                };
                System.out.println( "Difference.PeriodZero"+ aobj1);
            }

        if(ad.length > 0)
        {
            for(int l = 0; l < ad.length; l++)
                if(Double.isNaN(ad[l]))
                {
                    Object aobj2[] = {
                        new Integer(l)
                    };
                    System.out.println( "Difference.ZContainsNaN"+ aobj2);
                }

        }
        int i2 = ad2.length;
        double ad3[] = new double[ad2.length];
        System.arraycopy(ad, 0, ad3, 0, ad.length);
        nlost = 0;
        for(int l1 = ndiff; l1 >= 1; l1--)
        {
            for(int k1 = 1; k1 <= iord[l1 - 1]; k1++)
            {
                nlost += iper[l1 - 1];
                for(int i1 = 1; i1 <= ad2.length; i1++)
                {
                    if(i1 <= nlost)
                    {
                        ad3[i1 - 1] = (0.0D / 0.0D);
                        continue;
                    }
                    if(i1 > nlost)
                        ad3[i1 - 1] = ad2[i1 - 1] - ad2[i1 - iper[l1 - 1] - 1];
                }

                for(int j2 = 0; j2 < ad3.length; j2++)
                    ad2[j2] = ad3[j2];

            }

        }

        int k2 = imiss * nlost;
        nobsx = i2 - k2;
        if(imiss == 1)
            nobsx = Math.max(0, nobsx);
        double ad1[] = new double[ad3.length - k2];
        for(int j1 = k2; j1 < ad3.length; j1++)
            ad1[j1 - k2] = ad3[j1];

        return ad1;
    }



}
