
package utility.forecasting;

import java.util.Random;

// Referenced classes of package 
//            IEEE

public final class JMath
{

	 public static final double PI = Double.longBitsToDouble(0x400921fb54442d18L);
    public static final double E = Double.longBitsToDouble(0x4005bf0a8b145769L);
    private static final Random random = new Random();
    private static final double huge = 1.0000000000000001E+300D;
    private static final double tiny = 1E-300D;
    private static final double TWO52[] = {
        Double.longBitsToDouble(0x4330000000000000L), Double.longBitsToDouble(0xc330000000000000L)
    };
    private static final double NEGATIVE_ZERO = Double.longBitsToDouble(0x8000000000000000L);
    private static final double halF[] = {
        0.5D, -0.5D
    };
    private static final double o_threshold = Double.longBitsToDouble(0x40862e42fefa39efL);
    private static final double u_threshold = Double.longBitsToDouble(0xc0874910d52d3051L);
    private static final double ln2HI[] = {
        Double.longBitsToDouble(0x3fe62e42fee00000L), Double.longBitsToDouble(0xbfe62e42fee00000L)
    };
    private static final double ln2LO[] = {
        Double.longBitsToDouble(0x3dea39ef35793c76L), Double.longBitsToDouble(0xbdea39ef35793c76L)
    };
    private static final double invln2 = Double.longBitsToDouble(0x3ff71547652b82feL);
    private static final double P1 = Double.longBitsToDouble(0x3fc555555555553eL);
    private static final double P2 = Double.longBitsToDouble(0xbf66c16c16bebd93L);
    private static final double P3 = Double.longBitsToDouble(0x3f11566aaf25de2cL);
    private static final double P4 = Double.longBitsToDouble(0xbebbbd41c5d26bf1L);
    private static final double P5 = Double.longBitsToDouble(0x3e66376972bea4d0L);
    private static final double ln2_2 = 0.5D * Math.log(2D);
    private static final double ln2_32 = 1.5D * Math.log(2D);
    private static final double two_m28 = Double.longBitsToDouble(0x3e30000000000000L);
    private static final double ln2_hi = Double.longBitsToDouble(0x3fe62e42fee00000L);
    private static final double ln2_lo = Double.longBitsToDouble(0x3dea39ef35793c76L);
    private static final double Lg1 = Double.longBitsToDouble(0x3fe5555555555593L);
    private static final double Lg2 = Double.longBitsToDouble(0x3fd999999997fa04L);
    private static final double Lg3 = Double.longBitsToDouble(0x3fd2492494229359L);
    private static final double Lg4 = Double.longBitsToDouble(0x3fcc71c51d8e78afL);
    private static final double Lg5 = Double.longBitsToDouble(0x3fc7466496cb03deL);
    private static final double Lg6 = Double.longBitsToDouble(0x3fc39a09d078c69fL);
    private static final double Lg7 = Double.longBitsToDouble(0x3fc2f112df3e5244L);
    private static final double S1 = -0.16666666666666632D;
    private static final double S2 = 0.0083333333333224895D;
    private static final double S3 = -0.00019841269829857949D;
    private static final double S4 = 2.7557313707070068E-006D;
    private static final double S5 = -2.5050760253406863E-008D;
    private static final double S6 = 1.5896909952115501E-010D;
    private static final double PI_4 = Double.longBitsToDouble(0x3fe921fb00000000L);
    private static final double TWO_M27 = Double.longBitsToDouble(0x3e40000000000000L);
    private static final double one = Double.longBitsToDouble(0x3ff0000000000000L);
    private static final double C1 = Double.longBitsToDouble(0x3fa555555555554cL);
    private static final double C2 = Double.longBitsToDouble(0xbf56c16c16c15177L);
    private static final double C3 = Double.longBitsToDouble(0x3efa01a019cb1590L);
    private static final double C4 = Double.longBitsToDouble(0xbe927e4f809c52adL);
    private static final double C5 = Double.longBitsToDouble(0x3e21ee9ebdb4b1c4L);
    private static final double C6 = Double.longBitsToDouble(0xbda8fae9be8838d4L);
    private static final double pio4 = Double.longBitsToDouble(0x3fe921fb54442d18L);
    private static final double pio4lo = Double.longBitsToDouble(0x3c81a62633145c07L);
    private static final double T[] = {
        Double.longBitsToDouble(0x3fd5555555555563L), Double.longBitsToDouble(0x3fc111111110fe7aL), Double.longBitsToDouble(0x3faba1ba1bb341feL), Double.longBitsToDouble(0x3f9664f48406d637L), Double.longBitsToDouble(0x3f8226e3e96e8493L), Double.longBitsToDouble(0x3f6d6d22c9560328L), Double.longBitsToDouble(0x3f57dbc8fee08315L), Double.longBitsToDouble(0x3f4344d8f2f26501L), Double.longBitsToDouble(0x3f3026f71a8d1068L), Double.longBitsToDouble(0x3f147e88a03792a6L),
        Double.longBitsToDouble(0x3f12b80f32f0a7e9L), Double.longBitsToDouble(0xbef375cbdb605373L), Double.longBitsToDouble(0x3efb2a7074bf7ad4L)
    };
    private static final double pio2_hi = Double.longBitsToDouble(0x3ff921fb54442d18L);
    private static final double pio2_lo = Double.longBitsToDouble(0x3c91a62633145c07L);
    private static final double pio4_hi = Double.longBitsToDouble(0x3fe921fb54442d18L);
    private static final double pS0 = Double.longBitsToDouble(0x3fc5555555555555L);
    private static final double pS1 = Double.longBitsToDouble(0xbfd4d61203eb6f7dL);
    private static final double pS2 = Double.longBitsToDouble(0x3fc9c1550e884455L);
    private static final double pS3 = Double.longBitsToDouble(0xbfa48228b5688f3bL);
    private static final double pS4 = Double.longBitsToDouble(0x3f49efe07501b288L);
    private static final double pS5 = Double.longBitsToDouble(0x3f023de10dfdf709L);
    private static final double qS1 = Double.longBitsToDouble(0xc0033a271c8a2d4bL);
    private static final double qS2 = Double.longBitsToDouble(0x40002ae59c598ac8L);
    private static final double qS3 = Double.longBitsToDouble(0xbfe6066c1b8d0159L);
    private static final double qS4 = Double.longBitsToDouble(0x3fb3b8c5b12e9282L);
    private static final double atanhi[] = {
        Double.longBitsToDouble(0x3fddac670561bb4fL), Double.longBitsToDouble(0x3fe921fb54442d18L), Double.longBitsToDouble(0x3fef730bd281f69bL), Double.longBitsToDouble(0x3ff921fb54442d18L)
    };
    private static final double atanlo[] = {
        Double.longBitsToDouble(0x3c7a2b7f222f65e2L), Double.longBitsToDouble(0x3c81a62633145c07L), Double.longBitsToDouble(0x3c7007887af0cbbdL), Double.longBitsToDouble(0x3c91a62633145c07L)
    };
    private static final double aT[] = {
        Double.longBitsToDouble(0x3fd555555555550dL), Double.longBitsToDouble(0xbfc999999998ebc4L), Double.longBitsToDouble(0x3fc24924920083ffL), Double.longBitsToDouble(0xbfbc71c6fe231671L), Double.longBitsToDouble(0x3fb745cdc54c206eL), Double.longBitsToDouble(0xbfb3b0f2af749a6dL), Double.longBitsToDouble(0x3fb10d66a0d03d51L), Double.longBitsToDouble(0xbfadde2d52defd9aL), Double.longBitsToDouble(0x3fa97b4b24760debL), Double.longBitsToDouble(0xbfa2b4442c6a6c2fL),
        Double.longBitsToDouble(0x3f90ad3ae322da11L)
    };
    private static final double pi_o_4 = Double.longBitsToDouble(0x3fe921fb54442d18L);
    private static final double pi_o_2 = Double.longBitsToDouble(0x3ff921fb54442d18L);
    private static final double pi_lo = Double.longBitsToDouble(0x3ca1a62633145c07L);
    private static final int two_over_pi[] = {
        0xa2f983, 0x6e4e44, 0x1529fc, 0x2757d1, 0xf534dd, 0xc0db62, 0x95993c, 0x439041, 0xfe5163, 0xabdebb,
        0xc561b7, 0x246e3a, 0x424dd2, 0xe00649, 0x2eea09, 0xd1921c, 0xfe1deb, 0x1cb129, 0xa73ee8, 0x8235f5,
        0x2ebb44, 0x84e99c, 0x7026b4, 0x5f7e41, 0x3991d6, 0x398353, 0x39f49c, 0x845f8b, 0xbdf928, 0x3b1ff8,
        0x97ffde, 0x5980f, 0xef2f11, 0x8b5a0a, 0x6d1f6d, 0x367ecf, 0x27cb09, 0xb74f46, 0x3f669e, 0x5fea2d,
        0x7527ba, 0xc7ebe5, 0xf17b3d, 0x739f7, 0x8a5292, 0xea6bfb, 0x5fb11f, 0x8d5d08, 0x560330, 0x46fc7b,
        0x6babf0, 0xcfbc20, 0x9af436, 0x1da9e3, 0x91615e, 0xe61b08, 0x659985, 0x5f14a0, 0x68408d, 0xffd880,
        0x4d7327, 0x310606, 0x1556ca, 0x73a8c9, 0x60e27b, 0xc08c6b
    };
    private static final int npio2_hw[] = {
        0x3ff921fb, 0x400921fb, 0x4012d97c, 0x401921fb, 0x401f6a7a, 0x4022d97c, 0x4025fdbb, 0x402921fb, 0x402c463a, 0x402f6a7a,
        0x4031475c, 0x4032d97c, 0x40346b9c, 0x4035fdbb, 0x40378fdb, 0x403921fb, 0x403ab41b, 0x403c463a, 0x403dd85a, 0x403f6a7a,
        0x40407e4c, 0x4041475c, 0x4042106c, 0x4042d97c, 0x4043a28c, 0x40446b9c, 0x404534ac, 0x4045fdbb, 0x4046c6cb, 0x40478fdb,
        0x404858eb, 0x404921fb
    };
    private static final double zero = 0D;
    private static final double half = Double.longBitsToDouble(0x3fe0000000000000L);
    private static final double two24 = Double.longBitsToDouble(0x4170000000000000L);
    private static final double invpio2 = Double.longBitsToDouble(0x3fe45f306dc9c883L);
    private static final double pio2_1 = Double.longBitsToDouble(0x3ff921fb54400000L);
    private static final double pio2_1t = Double.longBitsToDouble(0x3dd0b4611a626331L);
    private static final double pio2_2 = Double.longBitsToDouble(0x3dd0b4611a600000L);
    private static final double pio2_2t = Double.longBitsToDouble(0x3ba3198a2e037073L);
    private static final double pio2_3 = Double.longBitsToDouble(0x3ba3198a2e000000L);
    private static final double pio2_3t = Double.longBitsToDouble(0x397b839a252049c1L);
    private static final double PIo2[] = {
        Double.longBitsToDouble(0x3ff921fb40000000L), Double.longBitsToDouble(0x3e74442d00000000L), Double.longBitsToDouble(0x3cf8469880000000L), Double.longBitsToDouble(0x3b78cc5160000000L), Double.longBitsToDouble(0x39f01b8380000000L), Double.longBitsToDouble(0x387a252040000000L), Double.longBitsToDouble(0x36e3822280000000L), Double.longBitsToDouble(0x3569f31d00000000L)
    };
    private static final double twon24 = Double.longBitsToDouble(0x3e70000000000000L);
    private static final double bp[] = {
        1.0D, 1.5D
    };
    private static final double dp_h[] = {
        0.0D, Double.longBitsToDouble(0x3fe2b80340000000L)
    };
    private static final double dp_l[] = {
        0.0D, Double.longBitsToDouble(0x3e4cfdeb43cfd006L)
    };
    private static final double two53 = Double.longBitsToDouble(0x4340000000000000L);
    private static final double L1 = Double.longBitsToDouble(0x3fe3333333333303L);
    private static final double L2 = Double.longBitsToDouble(0x3fdb6db6db6fabffL);
    private static final double L3 = Double.longBitsToDouble(0x3fd55555518f264dL);
    private static final double L4 = Double.longBitsToDouble(0x3fd17460a91d4101L);
    private static final double L5 = Double.longBitsToDouble(0x3fcd864a93c9db65L);
    private static final double L6 = Double.longBitsToDouble(0x3fca7e284a454eefL);
    private static final double lg2 = Double.longBitsToDouble(0x3fe62e42fefa39efL);
    private static final double lg2_h = Double.longBitsToDouble(0x3fe62e4300000000L);
    private static final double lg2_l = -1.904654299957768E-009D;
    private static final double ovt = 8.0085662595372941E-017D;
    private static final double cp = Double.longBitsToDouble(0x3feec709dc3a03fdL);
    private static final double cp_h = Double.longBitsToDouble(0x3feec709e0000000L);
    private static final double cp_l = Double.longBitsToDouble(0xbe3e2fe0145b01f5L);
    private static final double ivln2 = Double.longBitsToDouble(0x3ff71547652b82feL);
    private static final double ivln2_h = Double.longBitsToDouble(0x3ff7154760000000L);
    private static final double ivln2_l = Double.longBitsToDouble(0x3e54ae0bf85ddf44L);
    private static final double two54 = Double.longBitsToDouble(0x4350000000000000L);
    private static final double twom54 = Double.longBitsToDouble(0x3c90000000000000L);
	
    private JMath()
    {
    }

    public static int abs(int i)
    {
        return i >= 0 ? i : -i;
    }

    public static long abs(long l)
    {
        return l >= 0L ? l : -l;
    }

    public static float abs(float f)
    {
        return f > 0.0F ? f : 0.0F - f;
    }

    public static double abs(double d)
    {
        return d > 0.0D ? d : 0.0D - d;
    }

    public static int min(int i, int j)
    {
        return i >= j ? j : i;
    }

    public static long min(long l, long l1)
    {
        return l >= l1 ? l1 : l;
    }

    public static float min(float f, float f1)
    {
        if(Float.isNaN(f))
            return f;
        float f2 = f > f1 ? f1 : f;
        if(f2 == 0.0F && Float.floatToIntBits(f1) == 0x80000000)
            f2 = f1;
        return f2;
    }

    public static double min(double d, double d1)
    {
        if(Double.isNaN(d))
            return d;
        double d2 = d > d1 ? d1 : d;
        if(d == 0.0D && d1 == 0.0D && Double.doubleToLongBits(d1) == 0x8000000000000000L)
            d2 = d1;
        return d2;
    }

    public static int max(int i, int j)
    {
        return i <= j ? j : i;
    }

    public static long max(long l, long l1)
    {
        return l <= l1 ? l1 : l;
    }

    public static float max(float f, float f1)
    {
        if(Float.isNaN(f))
            return f;
        float f2 = f < f1 ? f1 : f;
        if((double)f == 0.0D && (double)f1 == 0.0D && Float.floatToIntBits(f) == 0x80000000)
            f2 = f1;
        return f2;
    }

    public static double max(double d, double d1)
    {
        if(Double.isNaN(d))
            return d;
        double d2 = d < d1 ? d1 : d;
        if(d == 0.0D && d1 == 0.0D && Double.doubleToLongBits(d) == 0x8000000000000000L)
            d2 = d1;
        return d2;
    }

    public static int round(float f)
    {
        return (int)floor(f + 0.5F);
    }

    public static long round(double d)
    {
        return (long)floor(d + 0.5D);
    }

    public static double random()
    {
        Random random1 = random;
        return random.nextDouble();

    }

    public static double ceil(double d)
    {
        if(d == 0.0D)
            return d;
        long l = Double.doubleToLongBits(d);
        int j = (int)(l >> 63 & 1L);
        int i = ((int)(l >> 52) & 0x7ff) - 1023;
        if(i < 0)
        {
            if(d < 0.0D)
                return NEGATIVE_ZERO;
            if(d == 0.0D)
                return d;
            else
                return 1.0D;
        }
        if(i < 53)
        {
            long l1 = 0xfffffffffffffL >>> i;
            if((l1 & l) == 0L)
                return d;
            if(d > 0.0D)
                l += 0x10000000000000L >> i;
            l &= ~l1;
        } else
        if(i == 1024)
            return d;
        return Double.longBitsToDouble(l);
    }

    public static double floor(double d)
    {
        if(d == 0.0D)
            return d;
        long l = Double.doubleToLongBits(d);
        int j = (int)(l >> 63 & 1L);
        int i = ((int)(l >> 52) & 0x7ff) - 1023;
        if(i < 0)
        {
            if(d < 0.0D)
                return -1D;
            if(d == 0.0D)
                return d;
            else
                return 0.0D;
        }
        if(i < 53)
        {
            long l1 = 0xfffffffffffffL >>> i;
            if((l1 & l) == 0L)
                return d;
            if(d < 0.0D)
                l += 0x10000000000000L >> i;
            l &= ~l1;
        } else
        if(i == 1024)
            return d;
        return Double.longBitsToDouble(l);
    }

    public static double rint(double d)
    {
        if(d == 0.0D)
            return d;
        long l = Double.doubleToLongBits(d);
        int j = (int)(l >> 63 & 1L);
        int i = ((int)(l >> 52) & 0x7ff) - 1023;
        if(i < 0)
        {
            if(d < -0.5D)
                return -1D;
            if(d > 0.5D)
                return 1.0D;
            if(j == 0)
                return 0.0D;
            else
                return NEGATIVE_ZERO;
        }
        if(i > 51)
            return d;
        if(i == 1024)
        {
            return d + d;
        } else
        {
            double d1 = TWO52[j] + d;
            return d1 - TWO52[j];
        }
    }

    public static double IEEEremainder(double d, double d1)
    {
        long l1 = Double.doubleToLongBits(d);
        int i = (int)(l1 >> 32);
        int l = (int)l1;
        long l2 = Double.doubleToLongBits(d1);
        int j = (int)(l2 >> 32);
        int i1 = (int)l2;
        int k = i & 0x80000000;
        j &= 0x7fffffff;
        i &= 0x7fffffff;
        if((j | i1) == 0)
            return (d * d1) / (d * d1);
        if(i >= 0x7ff00000 || j >= 0x7ff00000 && (j - 0x7ff00000 | i1) != 0)
            return (d * d1) / (d * d1);
        if(j <= 0x7fdfffff)
            d %= d1 + d1;
        if((i - j | l - i1) == 0)
            return 0.0D * d;
        d = abs(d);
        d1 = abs(d1);
        if(j < 0x200000)
        {
            if(d + d > d1)
            {
                d -= d1;
                if(d + d >= d1)
                    d -= d1;
            }
        } else
        {
            double d2 = 0.5D * d1;
            if(d > d2)
            {
                d -= d1;
                if(d >= d2)
                    d -= d1;
            }
        }
        l = HI(d);
        l ^= k;
        return setHI(d, l);
    }

    public static double sqrt(double d)
    {
        return Math.sqrt(d);
    }

    public static double exp(double d)
    {
        double d2 = 0.0D;
        double d3 = 0.0D;
        int i = 0;
        int j = d >= 0.0D ? 0 : 1;
        double d7 = abs(d);
        if(d7 >= o_threshold)
        {
            if(Double.isNaN(d))
                return d;
            if(d > 0.0D)
                return (1.0D / 0.0D);
            if(d < u_threshold)
                return 0.0D;
        }
        if(d7 > ln2_2)
        {
            if(d7 < ln2_32)
            {
                d2 = d - ln2HI[j];
                d3 = ln2LO[j];
                i = 1 - j - j;
            } else
            {
                i = (int)(invln2 * d + halF[j]);
                double d5 = i;
                d2 = d - d5 * ln2HI[0];
                d3 = d5 * ln2LO[0];
            }
            d = d2 - d3;
        } else
        if(d7 < two_m28)
        {
            if(1.0000000000000001E+300D + d > one)
                return one + d;
        } else
        {
            i = 0;
        }
        double d6 = d * d;
        double d4 = d - d6 * (P1 + d6 * (P2 + d6 * (P3 + d6 * (P4 + d6 * P5))));
        if(i == 0)
        {
            return one - ((d * d4) / (d4 - 2D) - d);
        } else
        {
            double d1 = one - (d3 - (d * d4) / (2D - d4) - d2);
            return IEEE.scalbn(d1, i);
        }
    }

    public static double log(double d)
    {
        long l = Double.doubleToLongBits(d);
        int i = (int)(l >> 32);
        int j = 0;
        if(i < 0x100000)
        {
            int k = (int)l;
            if((i & 0x7fffffff | k) == 0)
                return -two54 / 0.0D;
            if(i < 0)
                return (d - d) / 0.0D;
            j -= 54;
            d *= two54;
            l = Double.doubleToLongBits(d);
            i = (int)(l >> 32);
        }
        if(i >= 0x7ff00000)
            return d + d;
        j += (i >> 20) - 1023;
        i &= 0xfffff;
        int i1 = i + 0x95f64 & 0x100000;
        d = setHI(l, i | i1 ^ 0x3ff00000);
        j += i1 >> 20;
        double d10 = d - 1.0D;
        if((0xfffff & 2 + i) < 3)
        {
            if(d10 == 0.0D)
                if(j == 0)
                {
                    return 0.0D;
                } else
                {
                    double d7 = j;
                    return d7 * ln2_hi + d7 * ln2_lo;
                }
            double d2 = d10 * d10 * (0.5D - 0.33333333333333331D * d10);
            if(j == 0)
            {
                return d10 - d2;
            } else
            {
                double d8 = j;
                return d8 * ln2_hi - (d2 - d8 * ln2_lo - d10);
            }
        }
        double d11 = d10 / (2D + d10);
        double d9 = j;
        double d1 = d11 * d11;
        i1 = i - 0x6147a;
        double d4 = d1 * d1;
        int j1 = 0x6b851 - i;
        double d5 = d4 * (Lg2 + d4 * (Lg4 + d4 * Lg6));
        double d6 = d1 * (Lg1 + d4 * (Lg3 + d4 * (Lg5 + d4 * Lg7)));
        i1 |= j1;
        double d3 = d6 + d5;
        if(i1 > 0)
        {
            double d12 = 0.5D * d10 * d10;
            if(j == 0)
                return d10 - (d12 - d11 * (d12 + d3));
            else
                return d9 * ln2_hi - (d12 - (d11 * (d12 + d3) + d9 * ln2_lo) - d10);
        }
        if(j == 0)
            return d10 - d11 * (d10 - d3);
        else
            return d9 * ln2_hi - (d11 * (d10 - d3) - d9 * ln2_lo - d10);
    }

    public static double sin(double d)
    {
        if(abs(d) <= PI_4)
            return kernel_sin(d, 0.0D, 0);
        if(!IEEE.finite(d))
            return d - d;
        double ad[] = new double[2];
        int i = ieee_754_rem_pio2(d, ad);
        switch(i & 3)
        {
        case 0: // '\0'
            return kernel_sin(ad[0], ad[1], 1);

        case 1: // '\001'
            return kernel_cos(ad[0], ad[1]);

        case 2: // '\002'
            return -kernel_sin(ad[0], ad[1], 1);
        }
        return -kernel_cos(ad[0], ad[1]);
    }

    private static double kernel_sin(double d, double d1, int i)
    {
        if(abs(d) < TWO_M27 && (int)d == 0)
            return d;
        double d2 = d * d;
        double d3 = d2 * d;
        double d4 = 0.0083333333333224895D + d2 * (-0.00019841269829857949D + d2 * (2.7557313707070068E-006D + d2 * (-2.5050760253406863E-008D + d2 * 1.5896909952115501E-010D)));
        if(i == 0)
            return d + d3 * (-0.16666666666666632D + d2 * d4);
        else
            return d - (d2 * (half * d1 - d3 * d4) - d1 - d3 * -0.16666666666666632D);
    }

    public static double cos(double d)
    {
        if(abs(d) <= PI_4)
            return kernel_cos(d, 0.0D);
        if(!IEEE.finite(d))
            return d - d;
        double ad[] = new double[2];
        int i = ieee_754_rem_pio2(d, ad);
        switch(i & 3)
        {
        case 0: // '\0'
            return kernel_cos(ad[0], ad[1]);

        case 1: // '\001'
            return -kernel_sin(ad[0], ad[1], 1);

        case 2: // '\002'
            return -kernel_cos(ad[0], ad[1]);
        }
        return kernel_sin(ad[0], ad[1], 1);
    }

    private static double kernel_cos(double d, double d1)
    {
        int i = 0x7fffffff & (int)(Double.doubleToLongBits(d) >> 32);
        if(i < 0x3e400000 && (int)d == 0)
            return one;
        double d2 = d * d;
        double d3 = d2 * (C1 + d2 * (C2 + d2 * (C3 + d2 * (C4 + d2 * (C5 + d2 * C6)))));
        if(i < 0x3fd33333)
            return one - (0.5D * d2 - (d2 * d3 - d * d1));
        double d4;
        if(i > 0x3fe90000)
            d4 = 0.28125D;
        else
            d4 = set(i - 0x200000, 0);
        double d5 = 0.5D * d2 - d4;
        double d6 = one - d4;
        return d6 - (d5 - (d2 * d3 - d * d1));
    }

    public static double tan(double d)
    {
        if(abs(d) < PI_4)
            return kernel_tan(d, 0.0D, 1);
        if(!IEEE.finite(d))
        {
            return d - d;
        } else
        {
            double ad[] = new double[2];
            int i = ieee_754_rem_pio2(d, ad);
            return kernel_tan(ad[0], ad[1], 1 - ((i & 1) << 1));
        }
    }

    private static double kernel_tan(double d, double d1, int i)
    {
        long l = Double.doubleToLongBits(d);
        int j = (int)(l >> 32);
        int k = 0x7fffffff & j;
        if(k < 0x3e300000 && (int)d == 0)
        {
            if((k | (int)l | i + 1) == 0)
                return one / abs(d);
            if(i == 1)
            {
                return d;
            } else
            {
                double d11;
                double d2 = d11 = d + d1;
                d2 = setLO(d2, 0);
                double d7 = d1 - (d2 - d);
                double d17;
                double d19 = d17 = -one / d11;
                d19 = setLO(d19, 0);
                double d14 = one + d19 * d2;
                return d19 + d17 * (d14 + d19 * d7);
            }
        }
        if(k >= 0x3fe59428)
        {
            if(j < 0)
            {
                d = -d;
                d1 = -d1;
            }
            double d3 = pio4 - d;
            double d12 = pio4lo - d1;
            d = d3 + d12;
            d1 = 0.0D;
        }
        double d4 = d * d;
        double d13 = d4 * d4;
        double d6 = T[1] + d13 * (T[3] + d13 * (T[5] + d13 * (T[7] + d13 * (T[9] + d13 * T[11]))));
        double d8 = d4 * (T[2] + d13 * (T[4] + d13 * (T[6] + d13 * (T[8] + d13 * (T[10] + d13 * T[12])))));
        double d15 = d4 * d;
        d6 = d1 + d4 * (d15 * (d6 + d8) + d1);
        d6 += T[0] * d15;
        d13 = d + d6;
        if(k >= 0x3fe59428)
        {
            double d9 = i;
            return (double)(1 - (j >> 30 & 2)) * (d9 - 2D * (d - ((d13 * d13) / (d13 + d9) - d6)));
        }
        if(i == 1)
        {
            return d13;
        } else
        {
            double d5 = d13;
            d5 = setLO(d5, 0);
            double d10 = d6 - (d5 - d);
            double d18;
            double d20 = d18 = -1D / d13;
            d20 = setLO(d20, 0);
            double d16 = 1.0D + d20 * d5;
            return d20 + d18 * (d16 + d20 * d10);
        }
    }

    public static double asin(double d)
    {
        double d1 = 0.0D;
        long l = Double.doubleToLongBits(d);
        int i = (int)(l >> 32);
        int j = 0x7fffffff & i;
        if(j >= 0x3ff00000)
            if((j - 0x3ff00000 | (int)l) == 0)
                return d * pio2_hi + d * pio2_lo;
            else
                return (d - d) / (d - d);
        if(j < 0x3fe00000)
        {
            if(j < 0x3e400000)
            {
                if(1.0000000000000001E+300D + d > one)
                    return d;
            } else
            {
                d1 = d * d;
            }
            double d6 = d1 * (pS0 + d1 * (pS1 + d1 * (pS2 + d1 * (pS3 + d1 * (pS4 + d1 * pS5)))));
            double d8 = one + d1 * (qS1 + d1 * (qS2 + d1 * (qS3 + d1 * qS4)));
            double d2 = d6 / d8;
            return d + d * d2;
        }
        double d3 = one - abs(d);
        d1 = d3 * 0.5D;
        double d7 = d1 * (pS0 + d1 * (pS1 + d1 * (pS2 + d1 * (pS3 + d1 * (pS4 + d1 * pS5)))));
        double d9 = one + d1 * (qS1 + d1 * (qS2 + d1 * (qS3 + d1 * qS4)));
        double d12 = sqrt(d1);
        if(j >= 0x3fef3333)
        {
            double d4 = d7 / d9;
            d1 = pio2_hi - (2D * (d12 + d12 * d4) - pio2_lo);
        } else
        {
            double d5 = d12;
            d5 = setLO(d5, 0);
            double d10 = (d1 - d5 * d5) / (d12 + d5);
            double d11 = d7 / d9;
            d7 = 2D * d12 * d11 - (pio2_lo - 2D * d10);
            d9 = pio4_hi - 2D * d5;
            d1 = pio4_hi - (d7 - d9);
        }
        return i <= 0 ? -d1 : d1;
    }

    public static double acos(double d)
    {
        long l = Double.doubleToLongBits(d);
        int i = (int)(l >> 32);
        int j = 0x7fffffff & i;
        if(j >= 0x3ff00000)
            if((j - 0x3ff00000 | (int)l) == 0)
            {
                if(i > 0)
                    return 0.0D;
                else
                    return PI + 2D * pio2_lo;
            } else
            {
                return (d - d) / (d - d);
            }
        if(j < 0x3fe00000)
            if(j <= 0x3c600000)
            {
                return pio2_hi + pio2_lo;
            } else
            {
                double d1 = d * d;
                double d4 = d1 * (pS0 + d1 * (pS1 + d1 * (pS2 + d1 * (pS3 + d1 * (pS4 + d1 * pS5)))));
                double d7 = one + d1 * (qS1 + d1 * (qS2 + d1 * (qS3 + d1 * qS4)));
                double d10 = d4 / d7;
                return pio2_hi - (d - (pio2_lo - d * d10));
            }
        if(i < 0)
        {
            double d2 = (one + d) * 0.5D;
            double d5 = d2 * (pS0 + d2 * (pS1 + d2 * (pS2 + d2 * (pS3 + d2 * (pS4 + d2 * pS5)))));
            double d8 = one + d2 * (qS1 + d2 * (qS2 + d2 * (qS3 + d2 * qS4)));
            double d15 = sqrt(d2);
            double d11 = d5 / d8;
            double d13 = d11 * d15 - pio2_lo;
            return PI - 2D * (d15 + d13);
        } else
        {
            double d3 = (one - d) * 0.5D;
            double d16 = sqrt(d3);
            double d18 = d16;
            d18 = setLO(d18, 0);
            double d17 = (d3 - d18 * d18) / (d16 + d18);
            double d6 = d3 * (pS0 + d3 * (pS1 + d3 * (pS2 + d3 * (pS3 + d3 * (pS4 + d3 * pS5)))));
            double d9 = one + d3 * (qS1 + d3 * (qS2 + d3 * (qS3 + d3 * qS4)));
            double d12 = d6 / d9;
            double d14 = d12 * d16 + d17;
            return 2D * (d18 + d14);
        }
    }

    public static double atan(double d)
    {
        long l = Double.doubleToLongBits(d);
        int i = (int)(l >> 32);
        int j = i & 0x7fffffff;
        if(j >= 0x44100000)
        {
            if(j > 0x7ff00000 || j == 0x7ff00000 && (int)l != 0)
                return d + d;
            if(i > 0)
                return atanhi[3] + atanlo[3];
            else
                return -atanhi[3] - atanlo[3];
        }
        byte byte0;
        if(j < 0x3fdc0000)
        {
            if(j < 0x3e200000 && 1.0000000000000001E+300D + d > one)
                return d;
            byte0 = -1;
        } else
        {
            d = abs(d);
            if(j < 0x3ff30000)
            {
                if(j < 0x3fe60000)
                {
                    byte0 = 0;
                    d = (2D * d - one) / (2D + d);
                } else
                {
                    byte0 = 1;
                    d = (d - one) / (d + one);
                }
            } else
            if(j < 0x40038000)
            {
                byte0 = 2;
                d = (d - 1.5D) / (one + 1.5D * d);
            } else
            {
                byte0 = 3;
                d = -1D / d;
            }
        }
        double d2 = d * d;
        double d1 = d2 * d2;
        double d4 = d2 * (aT[0] + d1 * (aT[2] + d1 * (aT[4] + d1 * (aT[6] + d1 * (aT[8] + d1 * aT[10])))));
        double d5 = d1 * (aT[1] + d1 * (aT[3] + d1 * (aT[5] + d1 * (aT[7] + d1 * aT[9]))));
        if(byte0 < 0)
        {
            return d - d * (d4 + d5);
        } else
        {
            double d3 = atanhi[byte0] - (d * (d4 + d5) - atanlo[byte0] - d);
            return i >= 0 ? d3 : -d3;
        }
    }

    public static double atan2(double d, double d1)
    {
        long l = Double.doubleToLongBits(d1);
        int i = (int)(l >> 32);
        int j = (int)l;
        int k = i & 0x7fffffff;
        long l1 = Double.doubleToLongBits(d);
        int i1 = (int)(l1 >> 32);
        int j1 = (int)l1;
        int k1 = i1 & 0x7fffffff;
        if(Double.isNaN(d1) || Double.isNaN(d))
            return (0.0D / 0.0D);
        if(d1 == 1.0D)
            return atan(d);
        int i2 = i1 >> 31 & 1 | i >> 30 & 2;
        if(d == 0.0D)
            switch(i2)
            {
            case 0: // '\0'
            case 1: // '\001'
                return d;

            case 2: // '\002'
                return PI + 1E-300D;

            case 3: // '\003'
                return -PI - 1E-300D;
            }
        if(d1 == 0.0D)
            return i1 >= 0 ? pi_o_2 + 1E-300D : -pi_o_2 - 1E-300D;
        if(k == 0x7ff00000)
            if(k1 == 0x7ff00000)
                switch(i2)
                {
                case 0: // '\0'
                    return pi_o_4 + 1E-300D;

                case 1: // '\001'
                    return -pi_o_4 - 1E-300D;

                case 2: // '\002'
                    return 3D * pi_o_4 + 1E-300D;

                case 3: // '\003'
                    return -3D * pi_o_4 - 1E-300D;
                }
            else
                switch(i2)
                {
                case 0: // '\0'
                    return 0.0D;

                case 1: // '\001'
                    return -0D;

                case 2: // '\002'
                    return PI + 1E-300D;

                case 3: // '\003'
                    return -PI - 1E-300D;
                }
        if(k1 == 0x7ff00000)
            return i1 >= 0 ? pi_o_2 + 1E-300D : -pi_o_2 - 1E-300D;
        int j2 = k1 - k >> 20;
        double d2;
        if(j2 > 60)
            d2 = pi_o_2 + 0.5D * pi_lo;
        else
        if(i < 0 && j2 < -60)
            d2 = 0.0D;
        else
            d2 = atan(abs(d / d1));
        switch(i2)
        {
        case 0: // '\0'
            return d2;

        case 1: // '\001'
            return setHI(d2, HI(d2) ^ 0x80000000);

        case 2: // '\002'
            return PI - (d2 - pi_lo);
        }
        return d2 - pi_lo - PI;
    }

    private static int ieee_754_rem_pio2(double d, double ad[])
    {
        double d1 = 0.0D;
        int l1 = HI(d);
        int i2 = l1 & 0x7fffffff;
        if(i2 <= 0x3fe921fb)
        {
            ad[0] = d;
            ad[1] = 0.0D;
            return 0;
        }
        if(i2 < 0x4002d97c)
        {
            if(l1 > 0)
            {
                d1 = d - pio2_1;
                if(i2 != 0x3ff921fb)
                {
                    ad[0] = d1 - pio2_1t;
                    ad[1] = d1 - ad[0] - pio2_1t;
                } else
                {
                    d1 -= pio2_2;
                    ad[0] = d1 - pio2_2t;
                    ad[1] = d1 - ad[0] - pio2_2t;
                }
                return 1;
            }
            d1 = d + pio2_1;
            if(i2 != 0x3ff921fb)
            {
                ad[0] = d1 + pio2_1t;
                ad[1] = (d1 - ad[0]) + pio2_1t;
            } else
            {
                d1 += pio2_2;
                ad[0] = d1 + pio2_2t;
                ad[1] = (d1 - ad[0]) + pio2_2t;
            }
            return -1;
        }
        if(i2 <= 0x413921fb)
        {
            double d3 = abs(d);
            int j1 = (int)(d3 * invpio2 + half);
            double d7 = j1;
            double d6 = d3 - d7 * pio2_1;
            double d2 = d7 * pio2_1t;
            if(j1 < 32 && i2 != npio2_hw[j1 - 1])
            {
                ad[0] = d6 - d2;
            } else
            {
                int l = i2 >> 20;
                ad[0] = d6 - d2;
                int i = l - (HI(ad[0]) >> 20 & 0x7ff);
                if(i > 16)
                {
                    double d4 = d6;
                    d2 = d7 * pio2_2;
                    d6 = d4 - d2;
                    d2 = d7 * pio2_2t - (d4 - d6 - d2);
                    ad[0] = d6 - d2;
                    int j = l - (HI(ad[0]) >> 20 & 0x7ff);
                    if(j > 49)
                    {
                        double d5 = d6;
                        d2 = d7 * pio2_3;
                        d6 = d5 - d2;
                        d2 = d7 * pio2_3t - (d5 - d6 - d2);
                        ad[0] = d6 - d2;
                    }
                }
            }
            ad[1] = d6 - ad[0] - d2;
            if(l1 < 0)
            {
                ad[0] = -ad[0];
                ad[1] = -ad[1];
                return -j1;
            } else
            {
                return j1;
            }
        }
        if(i2 >= 0x7ff00000)
        {
            ad[0] = ad[1] = d - d;
            return 0;
        }
        long l2 = Double.doubleToLongBits(d);
        long l3 = (0x7ff0000000000000L & l2) >> 52;
        l3 -= 1046L;
        l2 -= l3 << 52;
        l2 &= 0x7fffffffffffffffL;
        d1 = Double.longBitsToDouble(l2);
        double ad1[] = new double[3];
        for(int k = 0; k < 2; k++)
        {
            ad1[k] = (int)d1;
            d1 = (d1 - ad1[k]) * two24;
        }

        ad1[2] = d1;
        int i1;
        for(i1 = 3; ad1[i1 - 1] == 0.0D; i1--);
        int k1 = kernel_rem_pio2(ad1, ad, (int)l3, i1);
        if(l1 < 0)
        {
            ad[0] = -ad[0];
            ad[1] = -ad[1];
            return -k1;
        } else
        {
            return k1;
        }
    }

    private static int kernel_rem_pio2(double ad[], double ad1[], int i, int j)
    {
        double ad2[] = new double[20];
        double ad3[] = new double[20];
        double ad4[] = new double[20];
        int ai[] = new int[20];
        byte byte0 = 4;
        byte byte1 = byte0;
        int j4 = j - 1;
        int k4 = (i - 3) / 24;
        if(k4 < 0)
            k4 = 0;
        int l4 = i - 24 * (k4 + 1);
        int i5 = k4 - j4;
        int i6 = j4 + byte0;
        for(int l = 0; l <= i6;)
        {
            ad2[l] = i5 >= 0 ? two_over_pi[i5] : 0.0D;
            l++;
            i5++;
        }

        for(int i1 = 0; i1 <= byte0; i1++)
        {
            int j5 = 0;
            double d = 0.0D;
            for(; j5 <= j4; j5++)
                d += ad[j5] * ad2[(j4 + i1) - j5];

            ad3[i1] = d;
        }

        int j6 = byte0;
        int k;
        int i4;
        double d5;
        do
        {
            int j1 = 0;
            int k5 = j6;
            d5 = ad3[j6];
            for(; k5 > 0; k5--)
            {
                double d1 = (int)(twon24 * d5);
                ai[j1] = (int)(d5 - two24 * d1);
                d5 = ad3[k5 - 1] + d1;
                j1++;
            }

            d5 = IEEE.scalbn(d5, l4);
            d5 -= 8D * floor(d5 * 0.125D);
            k = (int)d5;
            d5 -= k;
            i4 = 0;
            if(l4 > 0)
            {
                int k1 = ai[j6 - 1] >> 24 - l4;
                k += k1;
                ai[j6 - 1] -= k1 << 24 - l4;
                i4 = ai[j6 - 1] >> 23 - l4;
            } else
            if(l4 == 0)
                i4 = ai[j6 - 1] >> 23;
            else
            if(d5 >= 0.5D)
                i4 = 2;
            if(i4 > 0)
            {
                k++;
                boolean flag = false;
                for(int l1 = 0; l1 < j6; l1++)
                {
                    k5 = ai[l1];
                    if(!flag)
                    {
                        if(k5 != 0)
                        {
                            flag = true;
                            ai[l1] = 0x1000000 - k5;
                        }
                    } else
                    {
                        ai[l1] = 0xffffff - k5;
                    }
                }

                if(l4 > 0)
                    switch(l4)
                    {
                    case 1: // '\001'
                        ai[j6 - 1] &= 0x7fffff;
                        break;

                    case 2: // '\002'
                        ai[j6 - 1] &= 0x3fffff;
                        break;
                    }
                if(i4 == 2)
                {
                    d5 = one - d5;
                    if(flag)
                        d5 -= IEEE.scalbn(one, l4);
                }
            }
            if(d5 != 0.0D)
                break;
            k5 = 0;
            for(int i2 = j6 - 1; i2 >= byte0; i2--)
                k5 |= ai[i2];

            if(k5 != 0)
                break;
            int k3;
            for(k3 = 1; ai[byte0 - k3] == 0; k3++);
            for(int j2 = j6 + 1; j2 <= j6 + k3; j2++)
            {
                ad2[j4 + j2] = two_over_pi[k4 + j2];
                int l5 = 0;
                double d2 = 0.0D;
                for(; l5 <= j4; l5++)
                    d2 += ad[l5] * ad2[(j4 + j2) - l5];

                ad3[j2] = d2;
            }

            j6 += k3;
        } while(true);
        if(d5 == 0.0D)
        {
            j6--;
            for(l4 -= 24; ai[j6] == 0; l4 -= 24)
                j6--;

        } else
        {
            d5 = IEEE.scalbn(d5, -l4);
            if(d5 >= two24)
            {
                double d3 = (int)(twon24 * d5);
                ai[j6] = (int)(d5 - two24 * d3);
                j6++;
                l4 += 24;
                ai[j6] = (int)d3;
            } else
            {
                ai[j6] = (int)d5;
            }
        }
        double d4 = IEEE.scalbn(one, l4);
        for(int k2 = j6; k2 >= 0; k2--)
        {
            ad3[k2] = d4 * (double)ai[k2];
            d4 *= twon24;
        }

        for(int l2 = j6; l2 >= 0; l2--)
        {
            d4 = 0.0D;
            for(int l3 = 0; l3 <= byte1 && l3 <= j6 - l2; l3++)
                d4 += PIo2[l3] * ad3[l2 + l3];

            ad4[j6 - l2] = d4;
        }

        d4 = 0.0D;
        for(int i3 = j6; i3 >= 0; i3--)
            d4 += ad4[i3];

        ad1[0] = i4 != 0 ? -d4 : d4;
        d4 = ad4[0] - d4;
        for(int j3 = 1; j3 <= j6; j3++)
            d4 += ad4[j3];

        ad1[1] = i4 != 0 ? -d4 : d4;
        return k & 7;
    }

    public static double pow(double d, double d1)
    {
        long l2 = Double.doubleToLongBits(d);
        int i3 = (int)(l2 >> 32);
        int j3 = (int)l2;
        int k3 = i3 & 0x7fffffff;
        long l3 = Double.doubleToLongBits(d1);
        int i4 = (int)(l3 >> 32);
        int j4 = (int)l3;
        int k4 = i4 & 0x7fffffff;
        if((k4 | j4) == 0)
            return one;
        if(k3 > 0x7ff00000 || k3 == 0x7ff00000 && j3 != 0 || k4 > 0x7ff00000 || k4 == 0x7ff00000 && j4 != 0)
            return d + d1;
        int l4 = 0;
        if(i3 < 0)
            if(k4 >= 0x43400000)
                l4 = 2;
            else
            if(k4 >= 0x3ff00000)
            {
                int k1 = (k4 >> 20) - 1023;
                if(k1 > 20)
                {
                    int k = j4 >>> 52 - k1;
                    if(k << 52 - k1 == j4)
                        l4 = 2 - (k & 1);
                } else
                if(j4 == 0)
                {
                    int l = k4 >> 20 - k1;
                    if(l << 20 - k1 == k4)
                        l4 = 2 - (l & 1);
                }
            }
        if(j4 == 0)
        {
            if(k4 == 0x7ff00000)
            {
                if((k3 - 0x3ff00000 | j3) == 0)
                    return d1 - d1;
                if(k3 >= 0x3ff00000)
                    return i4 < 0 ? 0.0D : d1;
                else
                    return i4 >= 0 ? 0.0D : -d1;
            }
            if(k4 == 0x3ff00000)
                if(i4 < 0)
                    return one / d;
                else
                    return d;
            if(i4 == 0x40000000)
                return d * d;
            if(i4 == 0x3fe00000 && i3 >= 0)
                return sqrt(d);
        }
        double d4 = abs(d);
        if(j3 == 0 && (k3 == 0x7ff00000 || k3 == 0 || k3 == 0x3ff00000))
        {
            double d2 = d4;
            if(i4 < 0)
                d2 = one / d2;
            if(i3 < 0)
                if((k3 - 0x3ff00000 | l4) == 0)
                    d2 = (d2 - d2) / (d2 - d2);
                else
                if(l4 == 1)
                    d2 = -d2;
            return d2;
        }
        if(((i3 >> 31) + 1 | l4) == 0)
            return (d - d) / (d - d);
        double d12;
        double d13;
        if(k4 > 0x41e00000)
        {
            if(k4 > 0x43f00000)
            {
                if(k3 <= 0x3fefffff)
                    return i4 >= 0 ? 0.0D : (1.0D / 0.0D);
                if(k3 >= 0x3ff00000)
                    return i4 <= 0 ? 0.0D : (1.0D / 0.0D);
            }
            if(k3 < 0x3fefffff)
                return i4 >= 0 ? 0.0D : (1.0D / 0.0D);
            if(k3 > 0x3ff00000)
                return i4 <= 0 ? 0.0D : (1.0D / 0.0D);
            double d18 = d4 - 1.0D;
            double d28 = d18 * d18 * (0.5D - d18 * (0.33333333333333331D - d18 * 0.25D));
            double d22 = ivln2_h * d18;
            double d25 = d18 * ivln2_l - d28 * ivln2;
            d12 = d22 + d25;
            d12 = setLO(d12, 0);
            d13 = d25 - (d12 - d22);
        } else
        {
            int j2 = 0;
            if(k3 < 0x100000)
            {
                d4 *= two53;
                j2 -= 53;
                k3 = HI(d4);
            }
            j2 += (k3 >> 20) - 1023;
            int i1 = k3 & 0xfffff;
            k3 = i1 | 0x3ff00000;
            int l1;
            if(i1 <= 0x3988e)
                l1 = 0;
            else
            if(i1 < 0xbb67a)
            {
                l1 = 1;
            } else
            {
                l1 = 0;
                j2++;
                k3 -= 0x100000;
            }
            d4 = setHI(d4, k3);
            double d23 = d4 - bp[l1];
            double d26 = one / (d4 + bp[l1]);
            double d16 = d23 * d26;
            double d30 = d16;
            d30 = setLO(d30, 0);
            double d31 = 0.0D;
            d31 = setHI(d31, (k3 >> 1 | 0x20000000) + 0x80000 + (l1 << 18));
            double d32 = d4 - (d31 - bp[l1]);
            double d33 = d26 * (d23 - d30 * d31 - d30 * d32);
            double d34 = d16 * d16;
            double d14 = d34 * d34 * (L1 + d34 * (L2 + d34 * (L3 + d34 * (L4 + d34 * (L5 + d34 * L6)))));
            d14 += d33 * (d30 + d16);
            d34 = d30 * d30;
            d31 = 3D + d34 + d14;
            d31 = setLO(d31, 0);
            d32 = d14 - (d31 - 3D - d34);
            d23 = d30 * d31;
            d26 = d33 * d31 + d32 * d16;
            double d7 = d23 + d26;
            d7 = setLO(d7, 0);
            double d9 = d26 - (d7 - d23);
            double d5 = cp_h * d7;
            double d6 = cp_l * d7 + d9 * cp + dp_l[l1];
            double d19 = j2;
            d12 = d5 + d6 + dp_h[l1] + d19;
            d12 = setLO(d12, 0);
            d13 = d6 - (d12 - d19 - dp_h[l1] - d5);
        }
        double d17 = one;
        if(((i3 >> 31) + 1 | l4 - 1) == 0)
            d17 = -one;
        double d11 = d1;
        d11 = setLO(d11, 0);
        double d10 = (d1 - d11) * d12 + d1 * d13;
        double d8 = d11 * d12;
        double d3 = d10 + d8;
        long l5 = Double.doubleToLongBits(d3);
        int j1 = (int)(l5 >> 32);
        int i = (int)l5;
        if(j1 >= 0x40900000)
        {
            if((j1 - 0x40900000 | i) != 0)
                return d17 * 1.0000000000000001E+300D * 1.0000000000000001E+300D;
            if(d10 + 8.0085662595372941E-017D > d3 - d8)
                return d17 * 1.0000000000000001E+300D * 1.0000000000000001E+300D;
        } else
        if((j1 & 0x7fffffff) >= 0x4090cc00)
        {
            if((j1 - 0xc090cc00 | i) != 0)
                return d17 * 1E-300D * 1E-300D;
            if(d10 <= d3 - d8)
                return d17 * 1E-300D * 1E-300D;
        }
        i = j1 & 0x7fffffff;
        int i2 = (i >> 20) - 1023;
        int k2 = 0;
        if(i > 0x3fe00000)
        {
            k2 = j1 + (0x100000 >> i2 + 1);
            i2 = ((k2 & 0x7fffffff) >> 20) - 1023;
            double d20 = 0.0D;
            d20 = setHI(d20, k2 & ~(0xfffff >> i2));
            k2 = (k2 & 0xfffff | 0x100000) >> 20 - i2;
            if(j1 < 0)
                k2 = -k2;
            d8 -= d20;
        }
        double d21 = d10 + d8;
        d21 = setLO(d21, 0);
        double d24 = d21 * lg2_h;
        double d27 = (d10 - (d21 - d8)) * lg2 + d21 * -1.904654299957768E-009D;
        d3 = d24 + d27;
        double d29 = d27 - (d3 - d24);
        d21 = d3 * d3;
        d12 = d3 - d21 * (P1 + d21 * (P2 + d21 * (P3 + d21 * (P4 + d21 * P5))));
        double d15 = (d3 * d12) / (d12 - 2D) - (d29 + d3 * d29);
        d3 = one - (d15 - d3);
        j1 = HI(d3);
        j1 += k2 << 20;
        if(j1 >> 20 <= 0)
        {
            d3 = IEEE.scalbn(d3, k2);
        } else
        {
            int j = HI(d3);
            j += k2 << 20;
            d3 = setHI(d3, j);
        }
        return d17 * d3;
    }

    private static double set(int i, int j)
    {
        return Double.longBitsToDouble((long)i << 32 | (long)j);
    }

    private static double setLO(double d, int i)
    {
        long l = Double.doubleToLongBits(d);
        l &= 0xffffffff00000000L;
        l |= i;
        return Double.longBitsToDouble(l);
    }

    private static double setHI(double d, int i)
    {
        long l;
        if(d == 0.0D)
            l = 0L;
        else
            l = Double.doubleToLongBits(d);
        l &= 0xffffffffL;
        l |= (long)i << 32;
        return Double.longBitsToDouble(l);
    }

    private static double setHI(long l, int i)
    {
        l &= 0xffffffffL;
        l |= (long)i << 32;
        return Double.longBitsToDouble(l);
    }

    private static int HI(double d)
    {
        return (int)(Double.doubleToLongBits(d) >> 32);
    }


   

}
