/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package utility.forecasting;

import java.util.List;
import utility.CommonFunctions;

/**
 *
 * @author Alda
 */
public class SMA {
    private double[] smaTimeSeries; //Moving Average Data
    private int window;
    private int dataSize;
    public SMA(double[] timeSeries, int win){
        window = win;
        dataSize = timeSeries.length;
        if(window<dataSize){
            smaTimeSeries = new double[window];
            for(int i=0; i<window;i++)
                smaTimeSeries[0] = timeSeries[dataSize-i-1];
        }

    }
    
    public SMA(List<Double> timeSeries, int win){
        window = win;
        dataSize = timeSeries.size();
        if(window<dataSize){
            smaTimeSeries = new double[window];
            for(int i=0; i<window;i++)
                smaTimeSeries[0] = timeSeries.get(dataSize-i-1);
        }

    }

    /**
     *  Using the data given in the constructor, simply predicts one next time
     *  series value
     * @return
     */
    public double getNextPrediction(){
        if(window>=dataSize) return 0.0;
        return CommonFunctions.getAverage(smaTimeSeries);
    }

}
