package utility.forecasting;

import java.util.Random;

public class Sort
{
	private static final int MAX_SIZE_FOR_INSERTION = 20;
    private static final int MAX_SUBSET_FOR_INSERTION = 25;
    private static final int MEDIAN_OF_3_CUTOFF = 50;

    private static class RealMatrixQuickSort
    {

        public int medianKey(int i, int j)
        {
            int k = i + random.nextInt(j - i);
            int l = i + random.nextInt(j - i);
            int i1 = i + random.nextInt(j - i);
            if(compare(k, l, true) < 0)
                if(compare(l, i1, true) < 0)
                    return l;
                else
                    return compare(k, i1, true) >= 0 ? k : i1;
            if(compare(l, i1, true) < 0)
                return compare(k, i1, true) >= 0 ? i1 : k;
            else
                return l;
        }

        public void ascending(int i, int j)
        {
            stack.clear();
            stack.push(i, j);
            ascendingStack();
        }

        private void ascendingStack()
        {
            int i;
            int j;
            for(; !stack.empty(); ascendingImpl(i, j))
            {
                int ai[] = (int[])stack.pop();
                i = ai[0];
                j = ai[1];
            }

        }

        public void ascendingImpl(int i, int j)
        {
            impl(i, j, true);
        }

        public void impl(int i, int j, boolean flag)
        {
            if(j <= i)
                return;
            int k = i - 1;
            int l = j;
            int i1 = i - 1;
            int j1 = j;
            int k1;
            if(n < 50)
                k1 = i + random.nextInt(j - i);
            else
                k1 = medianKey(i, j);
            exch(k1, j);
            do
            {
                int l1;
                for(l1 = j; compare(++k, l1, flag) == -1;);
                while(compare(l1, --l, flag) == -1 && l != i) ;
                if(k >= l)
                    break;
                exch(k, l);
                if(compare(k, l1, flag) == 0)
                {
                    i1++;
                    exch(i1, k);
                }
                if(compare(l1, l, flag) == 0)
                {
                    j1--;
                    exch(l, j1);
                }
            } while(true);
            exch(k, j);
            l = k - 1;
            k++;
            for(int i2 = i; i2 < i1;)
            {
                exch(i2, l);
                i2++;
                l--;
            }

            for(int j2 = j - 1; j2 > j1;)
            {
                exch(k, j2);
                j2--;
                k++;
            }

            stack.push(i, l);
            stack.push(k, j);
        }

        public void descending(int i, int j)
        {
            stack.clear();
            stack.push(i, j);
            descendingStack();
        }

        private void descendingStack()
        {
            int i;
            int j;
            for(; !stack.empty(); descendingImpl(i, j))
            {
                int ai[] = (int[])stack.pop();
                i = ai[0];
                j = ai[1];
            }

        }

        public void descendingImpl(int i, int j)
        {
            impl(i, j, false);
        }

        private int compare(int i, int j, boolean flag)
        {
            boolean flag1 = false;
            boolean flag2 = false;
            byte byte0 = 0;
            for(int k = 0; k < indkeys.length; k++)
            {
                double d = a[i][indkeys[k]];
                double d1 = a[j][indkeys[k]];
                boolean flag3 = Double.isNaN(d);
                boolean flag4 = Double.isNaN(d1);
                flag1 = flag1 || flag3;
                flag2 = flag2 || flag4;
                if(byte0 != 0 || flag3 && flag4)
                    continue;
                if(flag3)
                {
                    byte0 = 1;
                    continue;
                }
                if(flag4)
                {
                    byte0 = -1;
                    continue;
                }
                if(d < d1)
                {
                    byte0 = ((byte)(flag ? -1 : 1));
                    continue;
                }
                if(d > d1)
                    byte0 = ((byte)(flag ? 1 : -1));
            }

            if(!flag1 || !flag2)
                if(flag1)
                    byte0 = 1;
                else
                if(flag2)
                    byte0 = -1;
            if(byte0 == 0 && iperm[i] != iperm[j])
                byte0 = ((byte)(iperm[i] >= iperm[j] ? 1 : -1));
            return byte0;
        }

        private void exch(int i, int j)
        {
            double ad[] = a[i];
            a[i] = a[j];
            a[j] = ad;
            if(iperm != null)
            {
                int k = iperm[i];
                iperm[i] = iperm[j];
                iperm[j] = k;
            }
        }

        private int n;
        private double a[][];
        private int indkeys[];
        private int iperm[];
        private IntPairStack stack;
        private Random random;

        public RealMatrixQuickSort(double ad[][], int ai[], int ai1[])
        {
            a = ad;
            n = ad.length;
            indkeys = ai;
            iperm = ai1;
            int i = (int)(4D * Math.log(n));
            stack = new IntPairStack(i);
            random = new Random();
        }
    }

    private static class RealQuickSort
    {

        public int medianKey(int i, int j)
        {
            int k = i + random.nextInt(j - i);
            int l = i + random.nextInt(j - i);
            int i1 = i + random.nextInt(j - i);
            double d = a[k];
            double d1 = a[l];
            double d2 = a[i1];
            if(d < d1)
                if(d1 < d2)
                    return l;
                else
                    return d >= d2 ? k : i1;
            if(d1 < d2)
                return d >= d2 ? i1 : k;
            else
                return l;
        }

        public void ascending(int i, int j)
        {
            stack.clear();
            stack.push(i, j);
            ascendingStack();
        }

        private void ascendingStack()
        {
            while(!stack.empty()) 
            {
                int ai[] = (int[])stack.pop();
                int i = ai[0];
                int j = ai[1];
                if(j - i < 25)
                {
                    if(iperm == null)
                        Sort.ascendingInsertion(a, i, j);
                    else
                        Sort.ascendingInsertion(a, i, j, iperm);
                } else
                {
                    ascendingImpl(i, j);
                }
            }
        }

        public void ascendingImpl(int i, int j)
        {
            if(j <= i)
                return;
            int k = i - 1;
            int l = j;
            int i1 = i - 1;
            int j1 = j;
            int k1;
            if(n < 50)
                k1 = i + random.nextInt(j - i);
            else
                k1 = medianKey(i, j);
            exch(k1, j);
            do
            {
                double d;
                for(d = a[j]; a[++k] < d;);
                while(d < a[--l] && l != i) ;
                if(k >= l)
                    break;
                exch(k, l);
                if(a[k] == d)
                {
                    i1++;
                    exch(i1, k);
                }
                if(d == a[l])
                {
                    j1--;
                    exch(l, j1);
                }
            } while(true);
            exch(k, j);
            l = k - 1;
            k++;
            for(int l1 = i; l1 < i1;)
            {
                exch(l1, l);
                l1++;
                l--;
            }

            for(int i2 = j - 1; i2 > j1;)
            {
                exch(k, i2);
                i2--;
                k++;
            }

            stack.push(i, l);
            stack.push(k, j);
        }

        public void descending(int i, int j)
        {
            stack.clear();
            stack.push(i, j);
            descendingStack();
        }

        private void descendingStack()
        {
            while(!stack.empty()) 
            {
                int ai[] = (int[])stack.pop();
                int i = ai[0];
                int j = ai[1];
                if(j - i < 25)
                {
                    if(iperm == null)
                        Sort.descendingInsertion(a, i, j);
                    else
                        Sort.descendingInsertion(a, i, j, iperm);
                } else
                {
                    descendingImpl(i, j);
                }
            }
        }

        public void descendingImpl(int i, int j)
        {
            if(j <= i)
                return;
            int k = i - 1;
            int l = j;
            int i1 = i - 1;
            int j1 = j;
            int k1;
            if(n < 50)
                k1 = i + random.nextInt(j - i);
            else
                k1 = medianKey(i, j);
            exch(k1, j);
            do
            {
                double d;
                for(d = a[j]; a[++k] > d;);
                while(d > a[--l] && l != i) ;
                if(k >= l)
                    break;
                exch(k, l);
                if(a[k] == d)
                {
                    i1++;
                    exch(i1, k);
                }
                if(d == a[l])
                {
                    j1--;
                    exch(l, j1);
                }
            } while(true);
            exch(k, j);
            l = k - 1;
            k++;
            for(int l1 = i; l1 < i1;)
            {
                exch(l1, l);
                l1++;
                l--;
            }

            for(int i2 = j - 1; i2 > j1;)
            {
                exch(k, i2);
                i2--;
                k++;
            }

            stack.push(i, l);
            stack.push(k, j);
        }

        private void exch(int i, int j)
        {
            double d = a[i];
            a[i] = a[j];
            a[j] = d;
            if(iperm != null)
            {
                int k = iperm[i];
                iperm[i] = iperm[j];
                iperm[j] = k;
            }
        }

        private int n;
        private double a[];
        private int iperm[];
        private IntPairStack stack;
        private Random random;

        public RealQuickSort(double ad[], int ai[])
        {
            a = ad;
            n = ad.length;
            iperm = ai;
            int i = (int)(4D * Math.log(n));
            stack = new IntPairStack(i);
            random = new Random();
        }
    }

    private static class IntegerQuickSort
    {

        public int medianKey(int i, int j)
        {
            int k = i + random.nextInt(j - i);
            int l = i + random.nextInt(j - i);
            int i1 = i + random.nextInt(j - i);
            int j1 = a[k];
            int k1 = a[l];
            int l1 = a[i1];
            if(j1 < k1)
                if(k1 < l1)
                    return l;
                else
                    return j1 >= l1 ? k : i1;
            if(k1 < l1)
                return j1 >= l1 ? i1 : k;
            else
                return l;
        }

        public void ascending(int i, int j)
        {
            stack.clear();
            stack.push(i, j);
            ascendingStack();
        }

        private void ascendingStack()
        {
            while(!stack.empty()) 
            {
                int ai[] = (int[])stack.pop();
                int i = ai[0];
                int j = ai[1];
                if(j - i < 25)
                {
                    if(iperm == null)
                        Sort.ascendingInsertion(a, i, j);
                    else
                        Sort.ascendingInsertion(a, i, j, iperm);
                } else
                {
                    ascendingImpl(i, j);
                }
            }
        }

        public void ascendingImpl(int i, int j)
        {
            if(j <= i)
                return;
            int k = i - 1;
            int l = j;
            int i1 = i - 1;
            int j1 = j;
            int k1;
            if(n < 50)
                k1 = i + random.nextInt(j - i);
            else
                k1 = medianKey(i, j);
            exch(k1, j);
            do
            {
                double d;
                for(d = a[j]; (double)a[++k] < d;);
                while(d < (double)a[--l] && l != i) ;
                if(k >= l)
                    break;
                exch(k, l);
                if((double)a[k] == d)
                {
                    i1++;
                    exch(i1, k);
                }
                if(d == (double)a[l])
                {
                    j1--;
                    exch(l, j1);
                }
            } while(true);
            exch(k, j);
            l = k - 1;
            k++;
            for(int l1 = i; l1 < i1;)
            {
                exch(l1, l);
                l1++;
                l--;
            }

            for(int i2 = j - 1; i2 > j1;)
            {
                exch(k, i2);
                i2--;
                k++;
            }

            stack.push(i, l);
            stack.push(k, j);
        }

        public void descending(int i, int j)
        {
            stack.clear();
            stack.push(i, j);
            descendingStack();
        }

        private void descendingStack()
        {
            while(!stack.empty()) 
            {
                int ai[] = (int[])stack.pop();
                int i = ai[0];
                int j = ai[1];
                if(j - i < 25)
                {
                    if(iperm == null)
                        Sort.descendingInsertion(a, i, j);
                    else
                        Sort.descendingInsertion(a, i, j, iperm);
                } else
                {
                    descendingImpl(i, j);
                }
            }
        }

        public void descendingImpl(int i, int j)
        {
            if(j <= i)
                return;
            int k = i - 1;
            int l = j;
            int i1 = i - 1;
            int j1 = j;
            int k1;
            if(n < 50)
                k1 = i + random.nextInt(j - i);
            else
                k1 = medianKey(i, j);
            exch(k1, j);
            do
            {
                double d;
                for(d = a[j]; (double)a[++k] > d;);
                while(d > (double)a[--l] && l != i) ;
                if(k >= l)
                    break;
                exch(k, l);
                if((double)a[k] == d)
                {
                    i1++;
                    exch(i1, k);
                }
                if(d == (double)a[l])
                {
                    j1--;
                    exch(l, j1);
                }
            } while(true);
            exch(k, j);
            l = k - 1;
            k++;
            for(int l1 = i; l1 < i1;)
            {
                exch(l1, l);
                l1++;
                l--;
            }

            for(int i2 = j - 1; i2 > j1;)
            {
                exch(k, i2);
                i2--;
                k++;
            }

            stack.push(i, l);
            stack.push(k, j);
        }

        private void exch(int i, int j)
        {
            int k = a[i];
            a[i] = a[j];
            a[j] = k;
            if(iperm != null)
            {
                int l = iperm[i];
                iperm[i] = iperm[j];
                iperm[j] = l;
            }
        }

        private int n;
        private int a[];
        private int iperm[];
        private IntPairStack stack;
        private Random random;

        public IntegerQuickSort(int ai[], int ai1[])
        {
            a = ai;
            n = ai.length;
            iperm = ai1;
            int i = (int)(4D * Math.log(n));
            stack = new IntPairStack(i);
            random = new Random();
        }
    }

    private static class IntPairStack
    {

        public void push(int i, int j)
        {
            depth = Math.max(depth, top);
            if(top == stack.length)
            {
                int ai[][] = new int[2 * top][2];
                System.arraycopy(stack, 0, ai, 0, top);
                stack = ai;
            }
            stack[top][0] = i;
            stack[top][1] = j;
            top++;
        }

        public int[] pop()
        {
            return stack[--top];
        }

        public void clear()
        {
            top = 0;
        }

        public boolean empty()
        {
            return top == 0;
        }

        public int size()
        {
            return top;
        }

        private int stack[][];
        private int top;
        public int depth;

        public IntPairStack(int i)
        {
            i = Math.max(10, i);
            stack = new int[i][2];
        }
    }


    private Sort()
    {
    }

    private static int filterNaN(double ad[])
    {
        int i = ad.length;
        if(i == 0)
            return i;
        for(; i > 0 && Double.isNaN(ad[i - 1]); i--);
        for(int j = 0; j < i; j++)
        {
            if(!Double.isNaN(ad[j]))
                continue;
            double d = ad[j];
            ad[j] = ad[i - 1];
            ad[i - 1] = d;
            for(i--; Double.isNaN(ad[i - 1]); i--);
        }

        for(; i > 0 && Double.isNaN(ad[i - 1]); i--);
        return i;
    }

    private static int filterNaN(double ad[], int ai[])
    {
        int i = ad.length;
        if(i == 0)
            return i;
        for(; i > 0 && Double.isNaN(ad[i - 1]); i--);
        for(int j = 0; j < i; j++)
        {
            if(!Double.isNaN(ad[j]))
                continue;
            double d = ad[j];
            ad[j] = ad[i - 1];
            ad[i - 1] = d;
            int k = ai[i - 1];
            ai[i - 1] = ai[j];
            ai[j] = k;
            for(i--; Double.isNaN(ad[i - 1]); i--);
        }

        for(; i > 0 && Double.isNaN(ad[i - 1]); i--);
        return i;
    }

    private static void initializePerm(int ai[])
    {
        if(ai != null)
        {
            for(int i = 0; i < ai.length; i++)
                ai[i] = i;

        }
    }

    public static void ascending(int ai[])
    {
        int i = ai.length;
        if(i < 20)
            ascendingInsertion(ai, 0, i - 1);
        else
            (new IntegerQuickSort(ai, null)).ascending(0, i - 1);
    }

    public static void descending(int ai[])
    {
        int i = ai.length;
        if(i < 20)
            descendingInsertion(ai, 0, i - 1);
        else
            (new IntegerQuickSort(ai, null)).descending(0, i - 1);
    }

    public static void ascending(int ai[], int ai1[])
    {
        if(ai.length != ai1.length)
        {
            Object aobj[] = {
                new Integer(ai1.length), new Integer(ai.length)
            };
            System.out.println("Sort.IpermTooSmall"+aobj);
        }
        initializePerm(ai1);
        int i = ai.length;
        if(i < 20)
            ascendingInsertion(ai, 0, i - 1, ai1);
        else
            (new IntegerQuickSort(ai, ai1)).ascending(0, i - 1);
    }

    public static void descending(int ai[], int ai1[])
    {
        if(ai.length != ai1.length)
        {
            Object aobj[] = {
                new Integer(ai1.length), new Integer(ai.length)
            };
            System.out.println("Sort.IpermTooSmall"+aobj);
        }
        initializePerm(ai1);
        int i = ai.length;
        if(i < 20)
            descendingInsertion(ai, 0, i - 1, ai1);
        else
            (new IntegerQuickSort(ai, ai1)).descending(0, i - 1);
    }

    public static void ascending(double ad[])
    {
        int i = filterNaN(ad);
        if(i < 20)
            ascendingInsertion(ad, 0, i - 1);
        else
            (new RealQuickSort(ad, null)).ascending(0, i - 1);
    }

    public static void descending(double ad[])
    {
        int i = filterNaN(ad);
        if(i < 20)
            descendingInsertion(ad, 0, i - 1);
        else
            (new RealQuickSort(ad, null)).descending(0, i - 1);
    }

    public static void ascending(double ad[], int ai[])
    {
        if(ad.length != ai.length)
        {
            Object aobj[] = {
                new Integer(ai.length), new Integer(ad.length)
            };
            System.out.println("Sort.IpermTooSmall"+aobj);
        }
        initializePerm(ai);
        int i = filterNaN(ad, ai);
        if(i < 20)
            ascendingInsertion(ad, 0, i - 1, ai);
        else
            (new RealQuickSort(ad, ai)).ascending(0, i - 1);
    }

    public static void descending(double ad[], int ai[])
    {
        if(ad.length != ai.length)
        {
            Object aobj[] = {
                new Integer(ai.length), new Integer(ad.length)
            };
            System.out.println("Sort.IpermTooSmall"+aobj);
        }
        initializePerm(ai);
        int i = filterNaN(ad, ai);
        if(i < 20)
            descendingInsertion(ad, 0, i - 1, ai);
        else
            (new RealQuickSort(ad, ai)).descending(0, i - 1);
    }

    public static void ascending(double ad[][], int i)
    {
        if(ad.length == 0)
            return;
        int ai[] = new int[ad.length];
        for(int j = 0; j < ad.length; j++)
            ai[j] = j;

        ascending(ad, i, ai);
    }

    public static void ascending(double ad[][], int ai[])
    {
        if(ad.length == 0)
            return;
        int ai1[] = new int[ad.length];
        for(int i = 0; i < ad.length; i++)
            ai1[i] = i;

        ascending(ad, ai, ai1);
    }

    public static void ascending(double ad[][], int i, int ai[])
    {
        if(ad.length == 0)
            return;
        int ai1[] = new int[i];
        for(int j = 0; j < i; j++)
            ai1[j] = j;

        ascending(ad, ai1, ai);
    }

    private static void ascendingInsertion(double ad[], int i, int j)
    {
        for(int k = i + 1; k <= j; k++)
        {
            double d = ad[k];
            int l;
            for(l = k - 1; l >= i && ad[l] > d; l--)
                ad[l + 1] = ad[l];

            ad[l + 1] = d;
        }

    }

    private static void ascendingInsertion(double ad[], int i, int j, int ai[])
    {
        for(int k = i + 1; k <= j; k++)
        {
            double d = ad[k];
            int l = ai[k];
            int i1;
            for(i1 = k - 1; i1 >= i && ad[i1] > d; i1--)
            {
                ad[i1 + 1] = ad[i1];
                ai[i1 + 1] = ai[i1];
            }

            ad[i1 + 1] = d;
            ai[i1 + 1] = l;
        }

    }

    private static void ascendingInsertion(int ai[], int i, int j)
    {
        for(int k = i + 1; k <= j; k++)
        {
            int l = ai[k];
            int i1;
            for(i1 = k - 1; i1 >= i && ai[i1] > l; i1--)
                ai[i1 + 1] = ai[i1];

            ai[i1 + 1] = l;
        }

    }

    private static void ascendingInsertion(int ai[], int i, int j, int ai1[])
    {
        for(int k = i + 1; k <= j; k++)
        {
            int l = ai[k];
            int i1 = ai1[k];
            int j1;
            for(j1 = k - 1; j1 >= i && ai[j1] > l; j1--)
            {
                ai[j1 + 1] = ai[j1];
                ai1[j1 + 1] = ai1[j1];
            }

            ai[j1 + 1] = l;
            ai1[j1 + 1] = i1;
        }

    }

    private static void descendingInsertion(double ad[], int i, int j)
    {
        for(int k = i + 1; k <= j; k++)
        {
            double d = ad[k];
            int l;
            for(l = k - 1; l >= i && ad[l] < d; l--)
                ad[l + 1] = ad[l];

            ad[l + 1] = d;
        }

    }

    private static void descendingInsertion(int ai[], int i, int j)
    {
        for(int k = i + 1; k <= j; k++)
        {
            int l = ai[k];
            int i1;
            for(i1 = k - 1; i1 >= i && ai[i1] < l; i1--)
                ai[i1 + 1] = ai[i1];

            ai[i1 + 1] = l;
        }

    }

    private static void descendingInsertion(double ad[], int i, int j, int ai[])
    {
        for(int k = i + 1; k <= j; k++)
        {
            double d = ad[k];
            int l = ai[k];
            int i1;
            for(i1 = k - 1; i1 >= i && ad[i1] < d; i1--)
            {
                ad[i1 + 1] = ad[i1];
                ai[i1 + 1] = ai[i1];
            }

            ad[i1 + 1] = d;
            ai[i1 + 1] = l;
        }

    }

    private static void descendingInsertion(int ai[], int i, int j, int ai1[])
    {
        for(int k = i + 1; k <= j; k++)
        {
            int l = ai[k];
            int i1 = ai1[k];
            int j1;
            for(j1 = k - 1; j1 >= i && ai[j1] < l; j1--)
            {
                ai[j1 + 1] = ai[j1];
                ai1[j1 + 1] = ai1[j1];
            }

            ai[j1 + 1] = l;
            ai1[j1 + 1] = i1;
        }

    }

    public static void ascending(double ad[][], int ai[], int ai1[])
    {
        if(ad.length == 0)
            return;
        int i = ad[0].length;
        int j = ai.length;
        if(j > i)
        {
            Object aobj[] = {
                new Integer(j), new Integer(i)
            };
            System.out.println("Sort.LessThanEqual"+aobj);
        }
        if(ai1.length != ad.length)
        {
            Object aobj1[] = {
                new Integer(ai1.length), new Integer(ad.length)
            };
            System.out.println("Sort.IpermTooSmall"+aobj1);
        }
        if(ad.length == 0)
            return;
        initializePerm(ai1);
        for(int k = 0; k < ai.length; k++)
            if(ai[k] < 0 || ai[k] >= i)
            {
                Object aobj2[] = {
                    new Integer(k), new Integer(ai[k]), new Integer(j)
                };
                System.out.println("Sort.InvalidIndiceKey"+aobj2);
            }

        (new RealMatrixQuickSort(ad, ai, ai1)).ascending(0, ad.length - 1);
    }

    public static void descending(double ad[][], int i)
    {
        int ai[] = new int[ad.length];
        for(int j = 0; j < ad.length; j++)
            ai[j] = j;

        descending(ad, i, ai);
    }

    public static void descending(double ad[][], int ai[])
    {
        int ai1[] = new int[ad.length];
        for(int i = 0; i < ad.length; i++)
            ai1[i] = i;

        descending(ad, ai, ai1);
    }

    public static void descending(double ad[][], int i, int ai[])
    {
        if(ad.length == 0)
            return;
        int ai1[] = new int[i];
        for(int j = 0; j < i; j++)
            ai1[j] = j;

        descending(ad, ai1, ai);
    }

    public static void descending(double ad[][], int ai[], int ai1[])
    {
        if(ad.length == 0)
            return;
        int i = ad[0].length;
        int j = ai.length;
        int k = ad.length;
        int l = ad[0].length;
        if(j > i)
        {
            Object aobj[] = {
                new Integer(j), new Integer(i)
            };
            System.out.println("Sort.LessThanEqual"+aobj);
        }
        if(ai1.length != ad.length)
        {
            Object aobj1[] = {
                new Integer(ai1.length), new Integer(ad.length)
            };
            System.out.println("Sort.IpermTooSmall"+aobj1);
        }
        initializePerm(ai1);
        for(int i1 = 0; i1 < ai.length; i1++)
            if(ai[i1] < 0 || ai[i1] >= i)
            {
                Object aobj2[] = {
                    new Integer(i1), new Integer(ai[i1]), new Integer(j)
                };
                System.out.println("Sort.InvalidIndiceKey"+aobj2);
            }

        (new RealMatrixQuickSort(ad, ai, ai1)).descending(0, ad.length - 1);
    }









}
