package utility.forecasting;


public class SuperMatrix
{
    public static class SuperNodal extends SuperMatrix
    {

        public int[] getSupernodeMapping()
        {
            return getCol_To_Sup();
        }

        public int getNumberOfSupernodes()
        {
            return getNsuper();
        }

        public void setNumberOfSuperNodes(int i)
        {
            setNsuper(i);
        }

        public int[] getvaluesColumnPtr()
        {
            return getNzval_Colptr();
        }

        public int getvaluesColumnPtr(int i)
        {
            return getNzval_Colptr(i);
        }

        public int[] getRowIndexColumnPtr()
        {
            return getRowind_Colptr();
        }

        public int getRowIndexColumnPtr(int i)
        {
            return getRowind_Colptr(i);
        }

        public int[] getSupernodeMapToColumn()
        {
            return getSup_To_Col();
        }

        public int getSup_To_Col(int i)
        {
            return getSup_To_Col(i);
        }

        public SuperNodal(int i, int j, int k, double ad[], int ai[], int ai1[], int ai2[], 
                int ai3[], int ai4[], int l)
        {
            super(i, j, k, ad, ai, ai1, ai2, ai3, ai4, l);
        }
    }

    public static class PermutedColumn extends SuperMatrix
    {

        public int[] getBeginColumn()
        {
            return getColBeg();
        }

        public int[] getEndColumn()
        {
            return getColEnd();
        }

        public PermutedColumn(int i, int j, int k, double ad[], int ai[], int ai1[], int ai2[], 
                int l)
        {
            super(i, j, k, ad, ai, ai1, ai2, l);
        }
    }

    public static class Dense extends SuperMatrix
    {

        public void copy(int i, int j, double ad[], int k, double ad1[], int l)
        {
            SuperMatrix.dCopyDenseMatrix(i, j, ad, k, ad1, l);
        }

        public int getLda()
        {
            return getLda();
        }

        public Dense(int i, int j, double ad[], int k, int l)
        {
            super(i, j, ad, k, l);
        }
    }

    class RowCompressed extends SuperMatrix
    {

        public SuperMatrix convertToColumnCompressed(int i, int j, int k, double ad[], int ai[], int ai1[])
        {
            return SuperMatrix.compRowToCompCol(i, j, k, ad, ai, ai1);
        }

        public int[] getColumnIndex()
        {
            return getColind();
        }

        public int[] getRowPtr()
        {
            return getRowptr();
        }

        public final SuperMatrix this$0;

        public RowCompressed(int i, int j, int k, double ad[], int ai[], int ai1[], int l)
        {
			super(i, j, k, ad, ai, ai1, 1, l);
            this$0 = SuperMatrix.this;
           
        }
    }

    public static class ColumnCompressed extends SuperMatrix
    {

        public int getColumnPtr(int i)
        {
            return getColptr(i);
        }

        public int[] getColumnPtr()
        {
            return getColptr();
        }

        public int getRowIndex(int i)
        {
            return getRowind(i);
        }

        public int[] getRowIndex()
        {
            return getRowind();
        }

        public ColumnCompressed(int i, int j, int k, double ad[], int ai[], int ai1[], int l)
        {
            super(i, j, k, ad, ai, ai1, 2, l);
        }
    }


    public SuperMatrix(int i, int j, int k, double ad[], int ai[], int ai1[], int l, 
            int i1)
    {
        matrixType = 1;
        nrows = i;
        ncols = j;
        nNonzeros = k;
        values = ad;
        storageType = l;
        matrixType = i1;
        if(l == 2)
        {
            rowIndex = ai;
            colPtr = ai1;
        } else
        if(l == 1)
        {
            colIndex = ai1;
            rowPtr = ai;
        }
    }

    public SuperMatrix(int i, int j, int k, double ad[], int ai[], int ai1[], int ai2[], 
            int l)
    {
        matrixType = 1;
        nrows = i;
        ncols = j;
        nNonzeros = k;
        values = ad;
        storageType = 3;
        matrixType = l;
        rowIndex = ai;
        colbeg = ai1;
        colend = ai2;
    }

    public SuperMatrix(int i, int j, int k, double ad[], int ai[], int ai1[], int ai2[], 
            int ai3[], int ai4[], int l)
    {
        matrixType = 1;
        nrows = i;
        ncols = j;
        nNonzeros = k;
        nsuper = ai3[j];
        values = ad;
        nzval_colptr = ai;
        rowIndex = ai1;
        rowind_colptr = ai2;
        col_to_sup = ai3;
        sup_to_col = ai4;
        storageType = 4;
        matrixType = l;
    }

    public SuperMatrix(int i, int j, double ad[], int k, int l)
    {
        matrixType = 1;
        nrows = i;
        ncols = j;
        lda = k;
        values = ad;
        storageType = 5;
        matrixType = l;
    }

    public void setMatrixType(int i)
    {
        if(i < 1 || i > 9)
        {
            Object aobj[] = {
                "matrixType", new Integer(i), new Integer(0), new Integer(10)
            };
            System.out.println("OutOfRange"+ aobj);
        }
        matrixType = i;
    }

    public int getStorageType()
    {
        return storageType;
    }

    public int getMatrixType()
    {
        return matrixType;
    }

    public int getNumberOfRows()
    {
        return nrows;
    }

    public int getNumberOfColumns()
    {
        return ncols;
    }

    public int getNumberOfNonzeros()
    {
        return nNonzeros;
    }

    public double[] getValues()
    {
        return values;
    }

    public int getColptr(int i)
    {
        return colPtr[i];
    }

    public int[] getColptr()
    {
        return colPtr;
    }

    public int getRowind(int i)
    {
        return rowIndex[i];
    }

    public int[] getRowind()
    {
        return rowIndex;
    }

    public int[] getRowptr()
    {
        return rowPtr;
    }

    public int[] getColind()
    {
        return colIndex;
    }

    public void setValue(int i, double d)
    {
        values[i] = d;
    }

    public int[] getColBeg()
    {
        return colbeg;
    }

    public int[] getColEnd()
    {
        return colend;
    }

    public int[] getSup_To_Col()
    {
        return sup_to_col;
    }

    public int getSup_To_Col(int i)
    {
        return sup_to_col[i];
    }

    public int[] getCol_To_Sup()
    {
        return col_to_sup;
    }

    public int[] getRowind_Colptr()
    {
        return rowind_colptr;
    }

    public int getRowind_Colptr(int i)
    {
        return rowind_colptr[i];
    }

    public int[] getNzval_Colptr()
    {
        return nzval_colptr;
    }

    public int getNzval_Colptr(int i)
    {
        return nzval_colptr[i];
    }

    public int getLda()
    {
        return lda;
    }

    public int getNsuper()
    {
        return nsuper;
    }

    public void setValues(double ad[])
    {
        values = ad;
    }

    public void setNumberOfNonzeros(int i)
    {
        nNonzeros = i;
    }

    public void setNsuper(int i)
    {
        nsuper = i;
    }

    public void setRowind(int ai[])
    {
        rowIndex = ai;
    }

    public void setColptr(int ai[])
    {
        colPtr = ai;
    }

    public void setNzval_Colptr(int ai[])
    {
        nzval_colptr = ai;
    }

    public void setRowind_Colptr(int ai[])
    {
        rowind_colptr = ai;
    }

    public static void dCopyDenseMatrix(int i, int j, double ad[], int k, double ad1[], int l)
    {
        for(int i1 = 0; i1 < j; i1++)
        {
            for(int j1 = 0; j1 < i; j1++)
                ad1[j1 + i1 * l] = ad[j1 + i1 * k];

        }

    }

    public static SuperMatrix compRowToCompCol(int i, int j, int k, double ad[], int ai[], int ai1[])
    {
        int ai2[] = null;
        int ai3[] = null;
        int ai4[] = null;
        double ad1[] = null;
        SuperMatrix supermatrix = null;
        ad1 = new double[k];
        ai3 = new int[k];
        ai4 = new int[j + 1];
        ai2 = new int[j];
        for(int l = 0; l < j; l++)
            ai2[l] = 0;

        for(int i1 = 0; i1 < i; i1++)
        {
            for(int k1 = ai1[i1]; k1 < ai1[i1 + 1]; k1++)
                ai2[ai[k1]]++;

        }

        ai4[0] = 0;
        for(int l1 = 0; l1 < j; l1++)
        {
            ai4[l1 + 1] = ai4[l1] + ai2[l1];
            ai2[l1] = ai4[l1];
        }

        for(int j1 = 0; j1 < i; j1++)
        {
            for(int i2 = ai1[j1]; i2 < ai1[j1 + 1]; i2++)
            {
                int j2 = ai[i2];
                int k2 = ai2[j2];
                ai3[k2] = j1;
                ad1[k2] = ad[i2];
                ai2[j2]++;
            }

        }

        ai2 = null;
        supermatrix = new SuperMatrix(i, j, k, ad1, ai3, ai4, 2, 1);
        return supermatrix;
    }

    public static void checkMatrix(SuperMatrix supermatrix)
    {
        if(supermatrix == null)
        {
            Object aobj[] = {
                "A"
            };
            System.out.println("SuperMatrix.IllegalReference"+ aobj);
        }
        int i = supermatrix.getNumberOfRows();
        int j = supermatrix.getNumberOfColumns();
        int k = supermatrix.getNumberOfNonzeros();
        double ad[] = supermatrix.getValues();
        if(i <= 0)
        {
            Object aobj1[] = {
                "A"
            };
             System.out.println("Matrix.NoOfRowsNotPositive"+ aobj1);
        }
        if(j <= 0)
        {
            Object aobj2[] = {
                "A"
            };
            System.out.println("Matrix.NoOfColsNotPositive"+ aobj2);
        }
        if(k < 0)
        {
            Object aobj3[] = {
                "A"
            };
             System.out.println("SparseMatrix.NoOfNonzerosNegative"+ aobj3);
        }
        if(ad == null)
        {
            Object aobj4[] = {
                "nzval"
            };
             System.out.println("SuperMatrix.IllegalReference_1"+ aobj4);
        }
        if(ad.length < k)
        {
            Object aobj5[] = {
                "nzval", new Integer(ad.length), new Integer(k)
            };
             System.out.println("TooFewPoints"+ aobj5);
        }
        int k1 = supermatrix.getStorageType();
        if(k1 == 2 || k1 == 1)
        {
            int l;
            int ai[];
            int ai1[];
            String s;
            String s1;
            if(k1 == 2)
            {
                ai = supermatrix.getRowind();
                ai1 = supermatrix.getColptr();
                s = "rowind";
                s1 = "colptr";
                l = j;
            } else
            {
                ai = supermatrix.getColind();
                ai1 = supermatrix.getRowptr();
                s = "colind";
                s1 = "rowptr";
                l = i;
            }
            if(ai == null)
            {
                Object aobj6[] = {
                    s
                };
                 System.out.println("SuperMatrix.IllegalReference_1"+ aobj6);
            }
            if(ai.length < k)
            {
                Object aobj7[] = {
                    s, new Integer(ai.length), new Integer(k)
                };
                System.out.println("TooFewPoints"+ aobj7);
            }
            if(ai1 == null)
            {
                Object aobj8[] = {
                    s1
                };
                System.out.println("SuperMatrix.IllegalReference_1"+ aobj8);
            }
            if(ai1.length < l + 1)
            {
                Object aobj9[] = {
                    s1, new Integer(ai1.length), new Integer(l + 1)
                };
                 System.out.println("TooFewPoints"+ aobj9);
            }
            if(ai1[0] != 0)
            {
                Object aobj10[] = {
                    s1, new Integer(0), new Integer(ai1[0]), new Integer(0)
                };
                 System.out.println("SuperMatrix.PtrRestriction"+aobj10);
            }
            if(ai1[l] != k)
            {
                Object aobj11[] = {
                    s1, new Integer(l), new Integer(ai1[l]), new Integer(k)
                };
                System.out.println("SuperMatrix.PtrRestriction"+aobj11);
            }
            for(int i1 = 0; i1 < j - 1; i1++)
                if(ai1[i1 + 1] < ai1[i1])
                {
                    Object aobj12[] = {
                        s1, new Integer(i1 + 1), new Integer(i1)
                    };
                     System.out.println("SuperMatrix.NonIncreasingOrder"+ aobj12);
                }

            for(int j1 = 0; j1 < k; j1++)
                if(ai[j1] < 0 || ai[j1] > i - 1)
                {
                    Object aobj13[] = {
                        s, new Integer(j1), new Integer(ai[j1]), new Integer(0), new Integer(l - 1)
                    };
                     System.out.println("SuperMatrix.IndexOutOfRange"+ aobj13);
                }

        }
    }
    public static final int ROW_COMPRESSED = 1;
    public static final int COLUMN_COMPRESSED = 2;
    public static final int PERMUTED_COLUMN = 3;
    public static final int SUPERNODAL_COLUMN = 4;
    public static final int DENSE_MATRIX = 5;
    public static final int GENERAL_MATRIX = 1;
    public static final int LOWER_TRIANGULAR_UNIT_DIAGONAL = 2;
    public static final int UPPER_TRIANGULAR_UNIT_DIAGONAL = 3;
    public static final int LOWER_TRIANGULAR = 4;
    public static final int UPPER_TRIANGULAR = 5;
    public static final int SYMMETRIC_STORED_IN_LOWER = 6;
    public static final int SYMMETRIC_STORED_IN_UPPER = 7;
    public static final int HERMITIAN_STORED_IN_LOWER = 8;
    public static final int HERMITIAN_STORED_IN_UPPER = 9;
    private int storageType;
    private int matrixType;
    private int nrows;
    private int ncols;
    private int nNonzeros;
    private double values[];
    private int rowIndex[];
    private int colPtr[];
    private int colIndex[];
    private int rowPtr[];
    private int nsuper;
    private int nzval_colptr[];
    private int rowind_colptr[];
    private int col_to_sup[];
    private int sup_to_col[];
    private int colbeg[];
    private int colend[];
    private int lda;

}
