package utility.reporting;

import java.util.ArrayList;
import java.util.Iterator;

import problem.Problem;

import solution.Solution;
import utility.Logger;
import utility.Utils;

public class CPReporting extends Reporting{
    private double [] runResults;
    private ArrayList<Solution> best;
    private int trialCounter;
    
    public CPReporting(int batches, String filename){
        super(batches, filename);
	trialCounter = 0;
	runResults = new double[noOfTrials];
	best = new ArrayList<Solution>();
    }
    
    @Override
    public void reportRun(){
	log.logLine(Logger.RESULTFILE, "Fitness, Mean seq length, , Solution, ");
	for (Iterator<Solution> iterator = best.iterator(); iterator.hasNext();){	   
	    String s = "";
	    Solution sol = (Solution) iterator.next();
	    s+= sol.getCurrentFitness()+", ";
	    s+= sol.getSolutionInSequence();
	    log.logLine(Logger.RESULTFILE, s);
	}
	runResults[trialCounter] /= best.size();
	trialCounter++;
    }
    
    @Override
    public void addBest(Solution sol){
	this.best.add(sol);
    }
    
    @Override
    public void reportBatch(){
	double average = 0;
	for (int i = 0; i < runResults.length; i++){
	    log.logLine(Logger.BATCHFILE, ""+runResults[i]);
	    average += runResults[i];
	}
	average /= runResults.length;
	double stdev = Utils.getStandardDeviation(runResults, average);
	log.logLine(Logger.BATCHFILE, "Average,"+average+",stdev, "+stdev);
        log.closeLogs();
    }
    
    @Override
    public void report(String s) {
        log.logLine(Logger.RESULTFILE, s);
    }

}
