package utility.reporting;

import utility.Logger;
import utility.Utils;

/**
 *
 * @author Alda
 */
public class LearningReporting extends Reporting{
    private double [] runResults;
    private int trialCounter;
    
    public LearningReporting(int batches, String filename){
        super(batches, filename);
	trialCounter = 0;
	runResults = new double[noOfTrials];
    }

    @Override
    public void reportRun() {
        
    }

    @Override
    public void reportBatch(){
       double average = 0;
	for (int i = 0; i < runResults.length; i++){
	    log.logLine(Logger.BATCHFILE, "" +runResults[i]);
	    average += runResults[i];
	}
	average /= runResults.length;
	double stdev = Utils.getStandardDeviation(runResults, average);
	log.logLine(Logger.BATCHFILE, "Average,"+average+",stdev, "+stdev);
    }

    @Override
    public void report(String s){
        log.logLine(Logger.RESULTFILE, "Run,"+trialCounter+","+s);
    }



}
