package utility.reporting;

import java.util.Iterator;
import java.util.LinkedList;

import solution.MOSolution;

import solution.Solution;
import utility.Logger;
import utility.MOResultsEvaluation;


public class MOReporting extends Reporting
{
    private MOResultsEvaluation resultsEvaluation;
    private LinkedList<LinkedList<MOSolution>> bestFronts;
    private int trialCounter;

    public MOReporting(int batches, String filename)
    {
        super(batches, filename);
	bestFronts = new LinkedList<LinkedList<MOSolution>>();
	resultsEvaluation = new MOResultsEvaluation();
    }
    
    @Override
    public void reportRun()
    {
	log.logLine(Logger.RESULTFILE, "Fitnesses for objectives, HV ");
	String s = "Run,"+trialCounter+",";
	double hv = this.resultsEvaluation.calculateHypervolumebySlicingObjectives(bestFronts.getLast());
	for (Iterator<MOSolution> iterator = bestFronts.getLast().iterator(); iterator.hasNext();)
	{	   
	    
	    MOSolution sol =  iterator.next();
	    for (int i = 0; i < sol.getAllFitnesses().length; i++)
	    {
		s+= sol.getFitnessForObjective(i)+", ";
	    }
	   s += "\n" ;
	    
  
	}
	s+= hv;
	log.logLine(Logger.RESULTFILE, s);
    }

    public void addToBest(LinkedList<MOSolution> list)
    {
	bestFronts.add(list);
	
    }

    @Override
    public void addBest(Solution sol)
    {
	// TODO Auto-generated method stub
	
    }

    @Override
    public void reportBatch()
    {
	// TODO Auto-generated method stub
	
    }

    @Override
    public void report(String s) {
        log.logLine(Logger.RESULTFILE, s);

    }

}
