package utility.reporting;

import java.util.ArrayList;
import java.util.Iterator;
import solution.Solution;
import utility.Logger;
import utility.Utils;
/**
 *
 * @author Alda
 */
public class SOReporting extends Reporting{
    private double [] runResults;
    private ArrayList<Solution> best;
    private int trialCounter;

    public SOReporting(int batches, String filename){
        super(batches, filename);
	trialCounter = 0;
        runResults = new double[noOfTrials];
    }
    @Override
    public void initialise(int batches, String fileName){
        super.initialise(batches,fileName);
        runResults = new double[noOfTrials];
    }

    public SOReporting(){
        best = new ArrayList<Solution>();
    }

    @Override
    public void restart(){
        best = new ArrayList<Solution>();
    }

    @Override
    public void reportRun() {
        String s = new String();
	for (Iterator<Solution> iterator = best.iterator(); iterator.hasNext();){
	    s = "Run,"+trialCounter+",Fitness,";
	    Solution sol = (Solution) iterator.next();
	    s+= sol.getCurrentFitness();
	    log.logLine(Logger.RESULTFILE, s);

	}
	runResults[trialCounter] = best.get(best.size()-1).getCurrentFitness();
	trialCounter++;
    }

    @Override
    public void addBest(Solution sol){best.add(sol);}

    @Override
    public void reportBatch(){
	double average = 0;
	for (int i = 0; i < runResults.length; i++){
 	    log.logLine(Logger.BATCHFILE, ""+runResults[i]);
	    average += runResults[i];
	}
	average /= runResults.length;
	double stdev = Utils.getStandardDeviation(runResults, average);
	log.logLine(Logger.BATCHFILE, "Average,"+average+",stdev, "+stdev);
        log.closeLogs();
    }

    @Override
    public void report(String s){
        log.logLine(Logger.RESULTFILE, s);

    }
}
