/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package learning.benchmarks;

public class Option {

	protected int times;
	protected double expectation;
	protected double v_scaling;
	protected int num;
	protected double dividePchapeau;
	protected boolean tried;

	protected Option(){
		
	}

	protected Option(int Num, double v_Scaling) {
		v_scaling = v_Scaling;
		num = Num;
		dividePchapeau = 1.0;
		initialize();
	}

	double score(double nb_total) {
		return (getExploitation() + getExploration(nb_total));
		//return (expectation + ( v_scaling * sqrt( 2 * log(nb_total) / times) ));
	}

	void setNormPchapeau(double _divide) {
		dividePchapeau = _divide;
	}

	double getNormPchapeau() {
		return dividePchapeau;
	}

	double getExploration(double nb_total) {
		//cout << nb_total << " " << times << endl;
		return (v_scaling * Math.sqrt(2.0 * Math.log((double) nb_total) / (double) times));
	}

	double getExploitation() {
		return (double) expectation / (double) dividePchapeau;
	}

	double getPchapeau() {
		return expectation;
	}

	void applyReward(double reward, double timeNow, boolean used) {
		//cout << "Applying reward " << reward << " to operator " << num << endl;
		// just updates the average
		expectation = ((double) times * expectation + reward) / ((double) times + 1);
		times++;
		tried = true;

	}

	void setTried(boolean tried_) {
		tried = tried_;
	}

	boolean getTried() {
		return tried;
	}

	void initialize() {
		expectation = 0.0;
		times = 0;
		tried = false;
	}

	int getTimes() {
		return times;
	}

	void setTimes(int _times) {
		times = _times;
	}

	double getTimesDyn() {
		return 0;
	}

	void setTimesDyn(double _times) {
	}
}
